
	; ----------------------------------------
	; Code operations used by Froth 'compiler'
	; ----------------------------------------

; MOV_EAX_xEAXi8	mov	eax, [eax + i8]
; MOVZX_EAX_bxEAXi8	movzx	eax, byte ptr [eax + i8]
; MOVZX_EAX_wxEAXi8	movzx	eax, word ptr [eax + i8]
; MOV_EAX_xEBXi8	mov	eax, [ebx + i8]
; MOV_EAX_xESIi8	mov	eax, [esi + i8]
; MOV_EBX_xESIi8	mov	ebx, [esi + i8]
; MOV_xEAXi8_EBX	mov	[eax + i8], ebx
; MOV_xEAXi8_BX		mov	[eax + i8], bx
; MOV_xEAXi8_BL		mov	[eax + i8], bl
; MOV_xEAXi8_i32	mov	dword ptr [eax + i8], i32
; ADD_xEAXi8_EBX	add	[eax + i8], ebx
; SUB_xEAXi8_EBX	sub	[eax + i8], ebx
; ADD_xESIi8_EAX	add	[esi + i8], eax
; SUB_xESIi8_EAX	sub	[esi + i8], eax
; ADD_xESIi8_i8		add	dword ptr [esi + i8], i8
; ADD_xESPi8_i8		add	dword ptr [esp + i8], i8
; SUB_xESIi8_i8		sub	dword ptr [esi + i8], i8
; INC_xEAXi8		inc	dword ptr [eax + i8]
; DEC_xEAXi8		dec	dword ptr [eax + i8]
; INC_xESIi8		inc	dword ptr [esi + i8]
; DEC_xESIi8		dec	dword ptr [esi + i8]
; ADD_ESI_i8		add	esi, i8
; SUB_ESI_i8		sub	esi, i8
; MOV_xESIi8_i32	mov	dword ptr [esi + i8], i32
; JE_rel8		je	rel8
; JE_rel32		je	rel32
; JMP_rel8		jmp	rel8
; JMP_rel32		jmp	rel32
; CALL_rel32		call	rel32
; OR_EAX_EAX		or	eax, eax
; MOV_xESIi8_EAX	mov	[esi + i8], eax
; MOV_xESIi8_EBX	mov	[esi + i8], ebx
; MOV_EAX_xEDIi32	mov	eax, [edi + i32]
; MOV_xMEM_i8		mov	[mem], i8
; BOUND_EAX_mem		bound	eax, qword ptr mem


		; --------------------
		; Store immediate byte
		; --------------------

StCodOp		MACRO	val
		push	ax
		mov	al, val
		call	CodeCComma					; CodeC,
		pop	ax
		ENDM


		; -------------------
		; Put 'RET' operation
		; -------------------
		
_RET_		MACRO
		StCodOp	0C3h
		ENDM


		; -------------------
		; Put 'NOP' operation
		; -------------------
		
_NOP_		MACRO	nb
		ifb	<nb>
			StCodOp	090h
		else
			REPT nb
				StCodOp	090h
			ENDM
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EAX, [EAX + i8]' operation
		; -----------------------------------

MOV_EAX_xEAXi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------------
		; Put 'MOVZX EAX, byte ptr [EAX + i8]' operation
		; ----------------------------------------------

MOVZX_EAX_bxEAXi8	MACRO	i8
		StCodOp	00Fh
		StCodOp	0B6h
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------------
		; Put 'MOVZX EAX, word ptr [EAX + i8]' operation
		; ----------------------------------------------

MOVZX_EAX_wxEAXi8	MACRO	i8
		StCodOp	00Fh
		StCodOp	0B7h
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EAX, [EBX + i8]' operation
		; -----------------------------------

MOV_EAX_xEBXi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	003h
		else
			StCodOp	043h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EAX, [ESI + i8]' operation
		; -----------------------------------

MOV_EAX_xESIi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EBX, [ESI + i8]' operation
		; -----------------------------------

MOV_EBX_xESIi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	01Eh
		else
			StCodOp	05Eh
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV [EAX + i8], EBX' operation
		; -----------------------------------

MOV_xEAXi8_EBX	MACRO	i8
		StCodOp	089h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------
		; Put 'MOV [EAX + i8], BX' operation
		; ----------------------------------

MOV_xEAXi8_BX	MACRO	i8
		StCodOp	066h
		StCodOp	089h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------
		; Put 'MOV [EAX + i8], BL' operation
		; ----------------------------------

MOV_xEAXi8_BL	MACRO	i8
		StCodOp	088h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; ---------------------------------------------
		; Put 'MOV dword ptr [EAX + i8], i32' operation
		; ---------------------------------------------

MOV_xEAXi8_i32	MACRO	i8, i32
		StCodOp	0C7h
		if	i8 eq 0
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		push	eax
		mov	eax, i32
		call	CodeComma               		; Code,
		pop	eax
		ENDM


		; -----------------------------------
		; Put 'ADD [EAX + i8], EBX' operation
		; -----------------------------------

ADD_xEAXi8_EBX	MACRO	i8
		StCodOp	001h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'SUB [EAX + i8], EBX' operation
		; -----------------------------------

SUB_xEAXi8_EBX	MACRO	i8
		StCodOp	029h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'ADD [ESI + i8], EAX' operation
		; -----------------------------------

ADD_xESIi8_EAX	MACRO	i8
		StCodOp	001h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'SUB [ESI + i8], EAX' operation
		; -----------------------------------

SUB_xESIi8_EAX	MACRO	i8
		StCodOp	029h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------------
		; Put 'ADD dword ptr [ESI + i8a], i8b' operation
		; ----------------------------------------------

ADD_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	006h
			StCodOp	i8b
		else
			StCodOp	046h
			StCodOp	i8a
			StCodOp	i8b
		endif
		ENDM


		; ------------------------------------
		; Put 'ADD DWORD PTR [esp + i8a], i8b'
		; ------------------------------------
		
ADD_xESPi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	004h
			StCodOp	024h
			StCodOp	i8b
		else
			StCodOp	044h
			StCodOp	024h
			StCodOp	i8a
			StCodOp	i8b
		endif
		ENDM


		; ----------------------------------------------
		; Put 'SUB dword ptr [ESI + i8a], i8b' operation
		; ----------------------------------------------

SUB_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	02Eh
			StCodOp	i8b
		else
			StCodOp	06Eh
			StCodOp	i8a
			StCodOp	i8b
		endif
		ENDM


		; ----------------------------------------
		; Put 'INC dword ptr [EAX + i8]' operation
		; ----------------------------------------

INC_xEAXi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------
		; Put 'DEC dword ptr [EAX + i8]' operation
		; ----------------------------------------

DEC_xEAXi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	008h
		else
			StCodOp	048h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------
		; Put 'INC dword ptr [ESI + i8]' operation
		; ----------------------------------------

INC_xESIi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------
		; Put 'DEC dword ptr [ESI + i8]' operation
		; ----------------------------------------

DEC_xESIi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	00Eh
		else
			StCodOp	04Eh
			StCodOp	i8
		endif
		ENDM


		; ---------------------------
		; Put 'ADD ESI, i8' operation
		; ---------------------------
		
ADD_ESI_i8	MACRO	i8
		StCodOp	083h
		StCodOp	0C6h
		StCodOp	i8
		ENDM
		

		; ---------------------------
		; Put 'SUB ESI, i8' operation
		; ---------------------------
		
SUB_ESI_i8	MACRO	i8
		StCodOp	083h
		StCodOp	0EEh
		StCodOp	i8
		ENDM


		; ---------------------------------------------
		; Put 'MOV DWORD PTR [ESI + i8], i32' operation
		; ---------------------------------------------
		
MOV_xESIi8_i32	MACRO	i8
		StCodOp	0C7h
 		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM
		

		; ----------------------------
		; Put 'JE rel8' code operation		
		; ----------------------------
		
JE_rel8		MACRO
		StCodOp	074h
		ENDM


		; -----------------------------
		; Put 'JE rel32' code operation		
		; -----------------------------
		
JE_rel32		MACRO
		StCodOp	00Fh
		StCodOp	084h
		ENDM


		; -----------------------------
		; Put 'JMP rel8' code operation		
		; -----------------------------

JMP_rel8		MACRO
		StCodOp	0EBh
		ENDM


		; ------------------------------
		; Put 'JMP rel32' code operation		
		; ------------------------------

JMP_rel32	MACRO
		StCodOp	0E9h
		ENDM


		; -------------------------------
		; Put 'CALL rel32' code operation
		; -------------------------------
		
CALL_rel32	MACRO
		StCodOp	0E8h
		ENDM


		; ---------------------------
		; Put 'OR EAX, EAX' operation
		; ---------------------------
		
OR_EAX_EAX	MACRO
		StCodOp	00Bh
		StCodOp	0C0h
		ENDM


		; -----------------------------------
		; Put 'MOV [ESI + i8], EAX' operation
		; -----------------------------------

MOV_xESIi8_EAX	MACRO	i8
		StCodOp	089h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV [ESI + i8], EBX' operation
		; -----------------------------------

MOV_xESIi8_EBX	MACRO	i8
		StCodOp	089h
		ifb	<i8>
			StCodOp	01Eh
		else
			StCodOp	05Eh
			StCodOp	i8
		endif
		ENDM


		; ------------------------------------
		; Put 'MOV EAX, [EDI + i32]' operation
		; ------------------------------------

MOV_EAX_xEDIi32	MACRO
		StCodOp	08Bh
		StCodOp	087h
		ENDM


		; --------------------------------
		; Put 'MOV [memory], i8' operation
		; --------------------------------

MOV_xMEM_i8	MACRO
		StCodOp	0C6h
		StCodOp	005h
							; Then: rel32  (memory relative address)
							; Then: i8
		ENDM

		
		; ----------------------------------------
		; Put 'BOUND eax, qword ptr mem' operation
		; ----------------------------------------

BOUND_EAX_mem	MACRO	mem
		StCodOp	062h
		StCodOp	005h
		push	eax
		mov	eax, offset mem
		call	CodeComma               		; Code,
		pop	eax
		ENDM

		
		; --------------------------
		; Put 'CALL_rel32' procedure
		; --------------------------

compCALL_rel32	MACRO	function
		CALL_rel32
		push	eax
		ifnb	<function>
			lea	eax, function
			add	eax, [OfsDictReloc]
		endif
		sub	eax, [CDA_START]
		sub	eax, [CDA_SIZE]
		sub	eax, 4				; 4 is for REL32
		call	CodeComma               		; Code,
		pop	eax
		ENDM


		; -------------------------
		; Put 'JMP_rel32' procedure
		; -------------------------

compJMP_rel32	MACRO	function
		JMP_rel32
		push	eax
		lea	eax, function
		add	eax, [OfsDictReloc]
		sub	eax, [CDA_START]
		sub	eax, [CDA_SIZE]
		sub	eax, 4				; 4 is for REL32
		call	CodeComma               		; Code,
		pop	eax
		ENDM
		
		
		; -----------------------
		; Code operation for INTO
		; -----------------------

INTO_codeop	equ	0CEh
		

