; ----------------------------------------------------------------------+
; FROTH - A forth language implementation on PC - Oliver SINGLA 	!
; 									!
; Module:	DICT.INC						!
; 									!
; Description:	Build the dictionnary (definitions, vocabularies,	!
; 		variables).						!
; 									!
; ----------------------------------------------------------------------+

	; ---------------
	; Vocabulary Area
	; ---------------
	
DEF	MACRO	name, father, lastword, num
	IFDEF __MAIN__
		vocentry <name, father, lastword - word_realaddr, 0>
	ENDIF
	num = X * size vocentry
	X = X + 1	
	ENDM
	
VOC_BEGIN:

		X = 0

		DEF "froth",		-1,		N_INTEGER,	VOCN_FROTH
		DEF "editor",		VOCN_FROTH,	N_ED_KEY,	VOCN_EDITOR
		DEF "screen",		VOCN_FROTH,	N_GETVIDEOMODE,	VOCN_SCREEN
		DEF "fkeys",		VOCN_FROTH,	N_KEY_F12,	VOCN_FKEYS
		DEF "serial",		VOCN_FROTH,	N_SERIALABORT,	VOCN_SERIAL
		DEF "portio",		VOCN_FROTH,	N_COUTPORT,	VOCN_PORTIO
		DEF "graphics",		VOCN_FROTH,	N_M800x600x16,	VOCN_GRAPHICS

		IFDEF __MAIN__
		dd  -1
		ENDIF

VOC_END:

	purge	DEF


	; --------------------
	; NIA : Name Info Area
	; --------------------

DEF	MACRO	name, fimm, fmacro, frunt, fnocomp, fbuilddoes, fncolondef, prev, next, real, runtaddr, iscodenum
	ifdef __MAIN__
		flags = FSYSTEM
		if fimm eq 1
			flags = flags + FIMMEDIATE
		endif
		if fmacro eq 1
			flags = flags + FMACRO
		endif
		if frunt
			flags = flags + FRUNTIME
		endif
		if fnocomp
			flags = flags + FNOCOMPILE
		endif
		if fbuilddoes
			flags = flags + FBUILDDOES
		endif
		if fncolondef eq 0
			flags = flags + FCOLONDEF
		endif
		if runtaddr eq 0
			rt_addr = 0
		else
			rt_addr = RT_&real
		endif
		if prev eq -1
			wordentry <name, flags, VOC, -1, next * size wordentry, real, rt_addr, E_&real - 1, -1>
		elseif next eq -1
			wordentry <name, flags, VOC, prev * size wordentry, -1, real, rt_addr, E_&real - 1, -1>
		else
			wordentry <name, flags, VOC, prev * size wordentry, next * size wordentry, real, rt_addr, E_&real - 1, -1>
		endif
	endif
	if iscodenum eq 1
		N_&real = X * size wordentry + word_realaddr
	endif
	if runtaddr ne 0
		R_&real = X * size wordentry + word_runtaddr
	endif
	X = X + 1
	ENDM

NIA_BEGIN:	

	X = 0
	
	; Vocabulary FROTH
	; ----------------
	
	VOC = VOCN_FROTH
	DEF "quit",		0, 0, 0, 0, 0, 0, -1,     %(X+1),	Quit,		0, 0
	DEF "interpret",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	INTERPRET,	0, 0
	DEF '"error',		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QERROR,		0, 0
	DEF 'WordName$',	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WORDNAME,	0, 0
	DEF "_readline",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	ReadLine,	0, 0
	DEF "_readloadline",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RdLoadFileLine,	0, 0
	DEF "?load",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QLOAD,		0, 0
	DEF "#if",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARPIF,	0, 0
	DEF "[if]",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARPIF,	0, 0
	DEF "#else",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARPELSE,	0, 0
	DEF "[else]",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARPELSE,	0, 0
	DEF "#endif",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARPENDIF,	0, 0
	DEF "[then]",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARPENDIF,	0, 0
	DEF "bye",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	BYE,		0, 0
	DEF "CtrlBreak_off",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CTRLBREAK_OFF,	0, 0
	DEF "CtrlBreak_restore", 0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CTRLBREAK_REST,	0, 0
	DEF "WordSize",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	WORDSIZE,	0, 0
	DEF "KbdFile",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KBDFILE,	0, 0
	DEF "?ok",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	QOK,		0, 1
	DEF "?safe",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	QSAFE,		0, 1
	DEF "?speed",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	QSPEED,		0, 1
	DEF "?iarithoverflow",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	QIARITHOVERFLOW, 0, 1
	DEF "?chat",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	QCHAT,		0, 1
	DEF "language",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	LANGUAGE,	0, 1
	DEF "english",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	ENGLISH,	0, 1
	DEF "french",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	FRENCH,		0, 1
	DEF "trace_page",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TRACE_PAGE,	0, 0
	DEF "trace_clear",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TRACE_CLEAR,	0, 0
	DEF "trace_begin",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TRACE_BEGIN,	0, 0
	DEF "trace_end",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TRACE_END,	0, 0
	DEF "trace_.",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TRACE_DOT,	0, 0
	DEF "trace_.S",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TRACE_DOTSTACK,	0, 0
	DEF "trace_type",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TRACE_TYPE	0, 0
	DEF ".S",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DOTS,		0, 0
	DEF "MaxNbThreads",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	MAXNBTHREADS,	0, 1
	DEF "NbThreads",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	NBTHREADS,	0, 0
	DEF "ActiveThread",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ACTIVETHREAD,	0, 0
	DEF "NewThread",	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	NEWTHREAD,	0, 0
	DEF "rt_NewThread",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doNewThread,	0, 0
	DEF "Yield",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	YIELD,		0, 0
	DEF "EndThread",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDTHREAD,	0, 0
	DEF "KillThread",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KILLTHREAD,	0, 0
	DEF "pemit",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PEMIT,		0, 0
	DEF "ptype",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PTYPE,		0, 0
	DEF "decimal",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DECIMAL,	0, 0
	DEF "hex",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	HEXADECIMAL,	0, 0
	DEF "<#",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BSHARP,		0, 0
	DEF "#",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARP,		0, 0
	DEF "U#",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	USHARP,		0, 0
	DEF "hold",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	HOLD,		0, 0
	DEF "sign",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SIGN,		0, 0
	DEF "#S",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SHARPS,		0, 0
	DEF "U#S",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	USHARPS,	0, 0
	DEF "#>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ESHARP,		0, 0
	DEF "<#S>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BSHARPSE,	0, 0
	DEF "number",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	NUMBER,		0, 0
	DEF ".",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DOT,		0, 0
	DEF ".R",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DOTR,		0, 0
	DEF ".L",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DOTL,		0, 0
	DEF "U.",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UDOT,		0, 0
	DEF "H.",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	HDOT,		0, 0
	DEF "02H.",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	Z2HDOT,		0, 0
	DEF 'rt_."',		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	PDOTQ,		0, 0
	DEF '."',		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DOTQUOTE,	0, 0
	DEF 'rt_"',		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	PQUOTE,		0, 0
	DEF '"',		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QUOTE,		0, 0
	DEF 'c"',		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QUOTE,		0, 0
	DEF 's"',		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QUOTE,		0, 0
	DEF "?compile",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QCOMPILE,	0, 0
	DEF "?execute",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QEXECUTE,	0, 0
	DEF "(",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	LPARENT,	0, 0
	DEF ")",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RPARENT,	0, 0
	DEF "//",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SLASHSLASH,	0, 0
	DEF "\",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SLASHSLASH,	0, 0
	DEF "rt_build>",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doBuild,	0, 0
	DEF "rt_LocalBuild>",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doLocalBuild,	0, 0
	DEF "build>",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BUILD,		0, 0
	DEF "create",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BUILD,		0, 0
	DEF ":",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	COLON,		0, 0
	DEF ";",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SEMICOLON,	0, 0
	DEF "immediate",	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	IMMEDIATE,	0, 0
	DEF "compile",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	COMPILE,	0, 0
	DEF "'",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TICK,		0, 0
	DEF "d'",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DTICK,		0, 0
	DEF "execute",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	EXECUTE,	0, 0
	DEF "recurse",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RECURSE,	0, 0
	DEF "myself",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MYSELF,		0, 0
	DEF "deferred",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	DEFERRED,	1, 0
	DEF "defer",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DEFER,		0, 0
	DEF "struct",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STRUCT,		0, 0
	DEF "endstruct",	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDSTRUCT,	0, 0
	DEF "words",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WORDS,		0, 0
	DEF "xwords",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	XWORDS,		0, 0
	DEF "vocs",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VOCS,		0, 0
	DEF "vocabulary",	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VOCABULARY,	0, 0
	DEF "current",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CURRENT,	0, 0
	DEF "forget",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FORGET,		0, 0
	DEF "update",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UPDATE,		0, 0
	DEF "save.exe",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	SAVE_EXE,	0, 0
	DEF "false",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	VFALSE,		0, 0
	DEF "true",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	VTRUE,		0, 0
	DEF "off",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	VFALSE,		0, 0
	DEF "on",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	VTRUE,		0, 0
	DEF "not",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROEQU,	0, 0
	DEF "0==",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROEQU,	0, 0
	DEF "0=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROEQU,	0, 0
	DEF "0!=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZERONEQU,	0, 0
	DEF "0<>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZERONEQU,	0, 0
	DEF "0<",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROLESS,	0, 0
	DEF "0<=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROLESSEQ	0, 0
	DEF "0>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROGREAT,	0, 0
	DEF "0>=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROGREATEQ,	0, 0
	DEF "begin",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BEGIN,		0, 0
	DEF "again",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	AGAIN,		0, 0
	DEF "until",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UNTIL,		0, 0
	DEF "if",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FIF,		0, 0
	DEF "else",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FELSE,		0, 0
	DEF "endif",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FENDIF,		0, 0
	DEF "then",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FENDIF,		0, 0
	DEF "i",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	I,		0, 0
	DEF "j",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	J,		0, 0
	DEF "k",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	K,		0, 0
	DEF "l",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	L,		0, 0
	DEF "m",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M,		0, 0
	DEF "rt_times",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doTimes,	0, 0
	DEF "times",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TIMES,		0, 0
	DEF "rt_endtimes",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doEndTimes,	0, 0
	DEF "endtimes",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDTIMES,	0, 0
	DEF "rt_do",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doDo,		0, 0
	DEF "do",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DO,		0, 0
	DEF "rt_when",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doWhen,		0, 0
	DEF "when",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WHEN,		0, 0
	DEF "rt_notwhen",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doNotWhen,	0, 0
	DEF "notwhen",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	NOTWHEN,	0, 0
	DEF "rt_enddo",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doEndDo,	0, 0
	DEF "enddo",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDDO,		0, 0
	DEF "loop",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDDO,		0, 0
	DEF "rt_+enddo",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doPEndDo,	0, 0
	DEF "+enddo",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PENDDO,		0, 0
	DEF "+loop",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PENDDO,		0, 0
	DEF "rt_+uenddo",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doPUEndDo,	0, 0
	DEF "+uenddo",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PUENDDO,	0, 0
	DEF "+uloop",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PUENDDO,	0, 0
	DEF "rt_make",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doMake,		0, 0
	DEF "make",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MAKE,		0, 0
	DEF "rt_+make",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doPlusMake,	0, 0
	DEF "+make",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PLUSMAKE,	0, 0
	DEF "rt_endmake",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doEndMake,	0, 0
	DEF "endmake",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDMAKE,	0, 0
	DEF "while",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	_WHILE,		0, 0
	DEF "repeat",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	REPEAT,		0, 0
	DEF "rt_case",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doCase,		0, 0
	DEF "case",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CASE,		0, 0
	DEF "rt_of",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doOf,		0, 0
	DEF "of",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	OF,		0, 0
	DEF "endof",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDOF,		0, 0
	DEF "tipof",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TIPOF,		0, 0
	DEF "rt_endcase",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	doEndCase,	0, 0
	DEF "endcase",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ENDCASE,	0, 0
	DEF "rt_?enought",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RT_QENOUGHT,	0, 0
	DEF "?enought",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QENOUGHT,	0, 0
	DEF "rt_stackoverflow?", 0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	OStack,		0, 0
	DEF "depth",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DEPTH,		0, 0
	DEF "drop",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	DROP,		0, 0
	DEF "ddrop",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	DDROP,		0, 0
	DEF "dup",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	_DUP,		0, 0
	DEF "ddup",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	DDUP,		0, 0
	DEF "pick",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PICK,		0, 0
	DEF "swap",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	SWAP,		0, 0
	DEF "dswap",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DSWAP,		0, 0
	DEF "over",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	OVER,		0, 0
	DEF "under",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	UNDER,		0, 0
	DEF "nip",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	UNDER,		0, 0
	DEF "above",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ABOVE,		0, 0
	DEF "below",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	BELOW,		0, 0
	DEF "tuck",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	TUCK,		0, 0
	DEF "rot",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ROT,		0, 0
	DEF "-rot",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MROT,		0, 0
	DEF "roll",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ROLL,		0, 0
	DEF "-roll",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MROLL,		0, 0
	DEF ">r",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TOR,		0, 0
	DEF "r>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FROMR,		0, 0
	DEF "r",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	R,		0, 0
	DEF "rdup",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RDUP,		0, 0
	DEF "rswap",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RSWAP,		0, 0
	DEF "rdrop",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RDROP,		0, 0
	DEF "runder",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RUNDER,		0, 0
	DEF "rbelow",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RBELOW,		0, 0
	DEF "rover",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ROVER,		0, 0
	DEF "rabove",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RABOVE,		0, 0
	DEF "rrot",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RROT,		0, 0
	DEF "r-rot",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RMROT,		0, 0
	DEF "base",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	_BASE,		0, 1
	DEF "negate",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	NEGATE,		0, 0
	DEF "min",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MIN,		0, 0
	DEF "max",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MAX,		0, 0
	DEF "umin",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UMIN,		0, 0
	DEF "umax",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UMAX,		0, 0
	DEF "+",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	PLUS,		0, 0
	DEF "1+",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ONEPLUS,	0, 0
	DEF "2+",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	TWOPLUS,	0, 0
	DEF "WordSize+",	0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	WORDSIZEPLUS,	0, 0
	DEF "-",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	MINUS,		0, 0
	DEF "1-",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ONEMINUS,	0, 0
	DEF "2-",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	TWOMINUS,	0, 0
	DEF "WordSize-",	0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	WORDSIZEMINUS,	0, 0
	DEF "*",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	STAR,		0, 0
	DEF "2*",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	TWOSTAR,	0, 0
	DEF "WordSize*",	0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	WORDSIZESTAR,	0, 0
	DEF "/",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	SLASH,		0, 0
	DEF "2/",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	TWOSLASH,	0, 0
	DEF "WordSize/",	0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	WORDSIZESLASH,	0, 0
	DEF "/mod",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SLASHMOD,	0, 0
	DEF "mod",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	IMOD,		0, 0
	DEF "*/",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STARSLASH,	0, 0
	DEF "*/mod",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STARSLASHMOD,	0, 0
	DEF "abs",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	IABS,		0, 0
	DEF "==",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	EQUAL,		0, 0
	DEF "=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	EQUAL,		0, 0
	DEF "!=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	NEQUAL,		0, 0
	DEF "<>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	NEQUAL,		0, 0
	DEF "<",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	LESS,		0, 0
	DEF "<=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	LESSEQ,		0, 0
	DEF ">",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GREAT,		0, 0
	DEF ">=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GREATEQ,	0, 0
	DEF "><",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GREATLESS,	0, 0
	DEF ">=<",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GREATEQLESS,	0, 0
	DEF "><=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GREATLESSEQ,	0, 0
	DEF ">=<=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GREATEQLESSEQ,	0, 0
	DEF "U<",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ULESS,		0, 0
	DEF "U<=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ULESSEQ,	0, 0
	DEF "U>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UGREAT,		0, 0
	DEF "U>=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UGREATEQ,	0, 0
	DEF "U><",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UGREATLESS,	0, 0
	DEF "U>=<",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UGREATEQLESS,	0, 0
	DEF "U><=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UGREATLESSEQ,	0, 0
	DEF "U>=<=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	UGREATEQLESSEQ,	0, 0
	DEF "and",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	IAND,		0, 0
	DEF "or",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	IOR,		0, 0
	DEF "xor",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	IXOR,		0, 0
	DEF "shl",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ISHL,		0, 0
	DEF "shr",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ISHR,		0, 0
	DEF "SetBit",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SETBIT,		0, 0
	DEF "ResetBit",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RESETBIT,	0, 0
	DEF "ComplBit",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	COMPLBIT,	0, 0
	DEF "GetBit",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GETBIT,		0, 0
	DEF "rnd",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RND,		0, 0
	DEF "mem",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	MEM,		0, 0
	DEF "infos",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	INFOS,		0, 0
	DEF "limits",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	LIMITS,		0, 0
	DEF "pmode",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	PMODE,		0, 0
	DEF '"load',		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	QUOTELOAD,	0, 0
	DEF 'load',		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	LOAD,		0, 0
	DEF "ed",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	ED,		0, 0
	DEF "use",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	USE,		0, 0
	ifdef UNDERDEV
	DEF "using?",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	USINGQ,		0, 0
	DEF ".voc",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	showVOC,	0, 0
	DEF ".nia",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	showNIA,	0, 0
	DEF ".cda",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	showCDA,	0, 0
	DEF ".ddir",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	showDDIR,	0, 0
	DEF ".cref",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	showCREF,	0, 0
	endif
	DEF "dump",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DUMP,		0, 0
	DEF "winf",		0, 0, 0, 1, 0, 0, %(X-1), %(X+1),	WINFOS,		0, 0
	DEF "(bmove)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PBMOVE,		0, 0
	DEF "(cmove)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PBMOVE,		0, 0
	DEF "bmove",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BMOVE,		0, 0
	DEF "cmove",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BMOVE,		0, 0
	DEF "fill",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FILL,		0, 0
	DEF "memfree",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MEMFREE,	0, 0

	DEF "[@]",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RAT,		0, 0
	DEF "(@)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PAT,		0, 0
	DEF "@",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	AT,		0, 0

	DEF "[C@]",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RCAT,		0, 0
	DEF "(C@)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PCAT,		0, 0
	DEF "C@",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	CAT,		0, 0

	DEF "[W@]",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	RWAT,		0, 0
	DEF "(W@)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PWAT,		0, 0
	DEF "W@",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	WAT,		0, 0

	DEF "(!)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PSTORE,		0, 0
	DEF "!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	STORE,		0, 0

	DEF "(C!)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PCSTORE,	0, 0
	DEF "C!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	CSTORE,		0, 0

	DEF "(W!)",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PWSTORE,	0, 0
	DEF "W!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	WSTORE,		0, 0

	DEF "@!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATSTORE,	0, 0
	DEF "@==",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATEQU,		0, 0
	DEF "@!=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATNEQU,		0, 0
	DEF "C@swap",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CATSWAP,	0, 0
	DEF "W@swap",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WATSWAP,	0, 0
	DEF "@swap",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATSWAP,		0, 0

	DEF "@0==",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATZEROEQU,	0, 0
	DEF "@0!=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATZERONEQU,	0, 0
	DEF "0!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ZEROSTORE,	0, 0
	DEF "1!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ONESTORE,	0, 0
	DEF "2!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TWOSTORE,	0, 0
	DEF "-1!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	MINUSONESTORE,	0, 0
	DEF "-2!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	MINUSTWOSTORE,	0, 0
	DEF "+!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	PLUSSTORE,	0, 0
	DEF "1+!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ONEPLUSSTORE,	0, 0
	DEF "2+!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	TWOPLUSSTORE,	0, 0
	DEF "-!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	MINUSSTORE,	0, 0
	DEF "1-!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	ONEMINUSSTORE,	0, 0
	DEF "2-!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	TWOMINUSSTORE,	0, 0
	DEF "*!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STARSTORE,	0, 0
	DEF "2*!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TWOSTARSTORE,	0, 0
	DEF "/!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SLASHSTORE,	0, 0
	DEF "2/!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TWOSLASHSTORE,	0, 0

	DEF "?",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QUEST,		0, 0
	DEF "C?",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CQUEST,		0, 0
	DEF "W?",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WQUEST,		0, 0

	DEF "dynamic",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DYNAMIC,	0, 0
	DEF "alloc",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ALLOCATE,	0, 0
	DEF "free",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FREE,		0, 0
	DEF "?AllotFail",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	QALLOTFAIL,	0, 1
	DEF "rt_allot",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RT_ALLOT,	0, 0
	DEF "allot",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ALLOT,		0, 0
	DEF "rt_ballot",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RT_BALLOT,	0, 0
	DEF "ballot",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BALLOT,		0, 0
	DEF "rt_wallot",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RT_WALLOT,	0, 0
	DEF "wallot",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WALLOT,		0, 0
	DEF "rt_AllotMore",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RT_ALLOTMORE,	0, 0
	DEF "AllotMore",	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ALLOTMORE,	0, 0
	DEF "rt_WAllotMore",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RT_WALLOTMORE,	0, 0
	DEF "WAllotMore",	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WALLOTMORE,	0, 0
	DEF "rt_BAllotMore",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	RT_BALLOTMORE,	0, 0
	DEF "BAllotMore",	1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BALLOTMORE,	0, 0
	DEF "rt_does>",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	PDOES,		0, 0
	DEF "does>",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DOES,		0, 0
	DEF "LocalVar",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	LocalVar,	0, 0
	DEF "FreeLocalVar",	0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	FreeLocalVar,	0, 0
	DEF "UnAllot",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	UnAllot,	0, 0
	DEF "DataSalvage",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DATASALVAGE,	0, 0
	DEF "DustThreshold",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	DUSTTHRESHOLD,	0, 1
	DEF "dust",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DUST,		0, 0
	DEF "emit",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	EMIT,		0, 0
	DEF "cr",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CR,		0, 0
	DEF "space",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SPACE,		0, 0
	DEF "spaces",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SPACES,		0, 0
	DEF "?AltKey",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QALTKEY,	0, 0
	DEF "?CtrlKey",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QCTRLKEY,	0, 0
	DEF "?ShiftKey",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QSHIFTKEY,	0, 0
	DEF "charin",		0, 0, 1, 1, 0, 0, %(X-1), %(X+1),	CharIn,		0, 0
	DEF "key",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY,		0, 0
	DEF "?key",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QKEY,		0, 0
	DEF "KeyIndice",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEYINDICE,	0, 0
	DEF "?KeyState",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QKEYSTATE,	0, 0
	DEF "type",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	_TYPE,		0, 0
	DEF "-type",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DTYPE,		0, 0
	DEF "type-",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TYPED,		0, 0
	DEF "charuppercase",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CHARUPCASE,	0, 0
	DEF "charlowercase",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CHARLOCASE,	0, 0
	DEF "[:",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	OPENASMBRACKET,	0, 0
	DEF ":]",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLOSEASMBRACKET, 0, 0
	DEF "FileIOStatus",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FILEIOSTATUS,	0, 0
	DEF "R/O",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FLAG_RO,	0, 0
	DEF "W/O",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FLAG_WO,	0, 0
	DEF "R/W",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FLAG_RW,	0, 0
	DEF "OpenFile",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	OPENFILE,	0, 0
	DEF "CloseFile",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLOSEFILE,	0, 0
	DEF "EmitFile",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	EMITFILE,	0, 0
	DEF "TypeFile",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TYPEFILE,	0, 0
	DEF "WriteFile",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WRITEFILE,	0, 0
	DEF "ReadFile",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	READFILE,	0, 0
	DEF "SeekFile",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SEEKFILE,	0, 0
	DEF "SeekSet",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SEEKSET,	0, 0
	DEF "SeekCur",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SEEKCUR,	0, 0
	DEF "SeekEnd",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SEEKEND,	0, 0
	DEF "FilePos",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FILEPOS,	0, 0
	DEF "FileSize",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FILESIZE,	0, 0
	DEF "DeleteFile",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DELETEFILE,	0, 0
	DEF "?FileExist",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	QFILEEXIST,	0, 0
	DEF "GetTime",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GETTIME,	0, 0
	DEF "GetDate",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GETDATE,	0, 0
	DEF "Time&Date",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GETDATE,	0, 0
	DEF "GetTicks",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GETTICKS,	0, 0
	DEF "delay",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DELAY,		0, 0
	DEF "FrothVersion",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FROTHVERSION,	0, 0
	DEF "FrothDate",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	FROTHDATE,	0, 0
	DEF "{",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	OPENBRACE,	0, 0
	DEF "}",		1, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLOSEBRACE,	0, 0

	DEF "fstring",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	FSTRING,	1, 1
	DEF "dstring",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	DSTRING,	1, 1
	DEF "null$",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	NULLSTR,	0, 1
	DEF "$len",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_LEN,	0, 0
	DEF "$mlen",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_MLEN,	0, 0
	DEF "$==",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_EQU,	0, 0
	DEF "$<",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_LESSEQ,	0, 0
	DEF "$<=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_LESS,	0, 0
	DEF "$>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_GREAT,	0, 0
	DEF "$>=",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_GREATEQ,	0, 0
	DEF "$!",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_STORE,	0, 0
	DEF "$add",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_ADD,	0, 0
	DEF "$+",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_ADD,	0, 0
	DEF "add$",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ADD_STR,	0, 0
	DEF "+$",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ADD_STR,	0, 0
	DEF "$replace",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_REPL,	0, 0
	DEF "$repl",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_REPL,	0, 0
	DEF "$find",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_FIND,	0, 0
	DEF "$copy",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_COPY,	0, 0
	DEF "$CopyToChar",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_COPY_TOC,	0, 0
	DEF "$shrink",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_SHRINK,	0, 0
	DEF "$convnb",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_CONVNB,	0, 0
	DEF "$searchchr",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_SRCHCHR,	0, 0
	DEF "$searchstr",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STR_SRCHSTR,	0, 0
	DEF "cstring",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	CSTRING,	1, 1

	DEF "logical",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	BOOLEAN,	1, 1
	DEF "ilogical",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	IBOOLEAN,	1, 1
	DEF "false!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	BOOL_FALSESTORE,0, 0
	DEF "true!",		0, 1, 0, 0, 0, 0, %(X-1), %(X+1),	BOOL_TRUESTORE,	0, 0
	DEF "false?",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BOOL_QFALSE,	0, 0
	DEF "true?",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BOOL_QTRUE,	0, 0
	DEF "constant",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	CONSTANT	1, 0
	DEF "const",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	CONSTANT	1, 0
	DEF "iint",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	IINTEGER,	1, 0
	DEF "variable",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	INTEGER,	1, 0
	DEF "int",		1, 0, 0, 0, 1, 0, %(X-1), -1,		INTEGER,	1, 1


	; Vocabulary EDITOR
	; -----------------
	
	VOC = VOCN_EDITOR
	DEF "C_StatusLabels",	0, 0, 0, 0, 0, 1, -1,     %(X+1),	EDC_SLL,	0, 1
	DEF "C_StatusInfos",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	EDC_SLI,	0, 1
	DEF "C_NormalText",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	EDC_TXN,	0, 1
	DEF "C_SelectedText",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	EDC_TXS,	0, 1
	DEF "C_NormHelp",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	EDC_HLN,	0, 1
	DEF "C_AltHelp",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	EDC_HLA,	0, 1
	DEF "C_KeysHelp",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	EDC_HLK,	0, 1
	DEF "VideoMode",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	ED_VIDEOMODE,	0, 1
	DEF "dir$",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	ED_DIR,		0, 1
	DEF "?DirectVideo",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	ED_QDIRECTVIDEO, 0, 1
	DEF "?UseTab",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	ED_QUSETAB,	0, 1
	DEF "CommentField",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	ED_COMMENTFIELD, 0, 1
	DEF "LinePosAdjust",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	ED_LINEPOSADJUST, 0, 1
	DEF "EditKey",		0, 0, 0, 0, 0, 1, %(X-1), -1,		ED_KEY,		0, 1
 

	; Vocabulary SCREEN
	; -----------------
	
	VOC = VOCN_SCREEN
	DEF "SetVideoMode",	0, 0, 0, 0, 0, 0, -1,     %(X+1),	SETVIDEOMODE,	0, 0
	DEF "#pages",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	NBPAGES,	0, 1
	DEF "page#",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	PAGENB		0, 1
	DEF "#rows",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	NBROWS,		0, 1
	DEF "#cols",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	NBCOLS,		0, 1
	DEF "page>",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SELECTPAGE	0, 0
	DEF ">page",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CHANGEPAGE	0, 0
	DEF "ScreenBackground", 0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	SCREENBCKG,	0, 1
	DEF "?UpdateCursor", 	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	QUPDATECURSOR,	0, 1
	DEF "cursor",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CURSOR,		0, 0
	DEF "gotoXY",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GOTOXY,		0, 0
	DEF "gotoX",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GOTOX,		0, 0
	DEF "gotoY",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GOTOY,		0, 0
	DEF "whereXY",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WHEREXY,	0, 0
	DEF "whereX",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WHEREX,		0, 0
	DEF "whereY",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WHEREY,		0, 0
	DEF "BackForeGround",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BACKFOREGROUND,	0, 0
	DEF "@xychar",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATXYCHAR,	0, 0
	DEF "@xyachar",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATXYACHAR,	0, 0
	DEF "!xychar",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREXYCHAR,	0, 0
	DEF "!xyachar",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREXYACHAR,	0, 0
	DEF "!xynchar",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREXYNCHAR,	0, 0
	DEF "!xynachar",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREXYNACHAR,	0, 0
	DEF "AttrCls",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ATTRCLS,	0, 0
	DEF "cls",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLS,		0, 0
	DEF "!string",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STORESTRING,	0, 0
	DEF "!astring",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREASTRING,	0, 0
	DEF "!xystring",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREXYSTRING,	0, 0
	DEF "!xyastring",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREXYASTRING,	0, 0
	DEF ">xylstring_char",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TOXYLSTRING_CHAR, 0, 0
	DEF ">xylstring_attr",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	TOXYLSTRING_ATTR, 0, 0
	DEF "!xylstring",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	STOREXYLSTRING,	0, 0
	DEF "clrline",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLRLINE,	0, 0
	DEF "aclrline",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ACLRLINE,	0, 0
	DEF "clreol",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLREOL,		0, 0
	DEF "aclreol",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ACLREOL,	0, 0
	DEF "loadcharset_8x8",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	LOADCHARSET_8x8, 0, 0
	DEF "loadcharset_8x14",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	LOADCHARSET_8x14, 0, 0
	DEF "loadcharset_8x16",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	LOADCHARSET_8x16, 0, 0
	DEF "Black",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VBLACK,		0, 0
	DEF "Blue",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VBLUE		0, 0
	DEF "Green",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VGREEN,		0, 0
	DEF "Cyan",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VCYAN,		0, 0
	DEF "Red",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VRED,		0, 0
	DEF "Magenta",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VMAGENTA,	0, 0
	DEF "Brown",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VBROWN,		0, 0
	DEF "LightGray",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VLIGHTGRAY,	0, 0
	DEF "DarkGray",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VDARKGRAY,	0, 0
	DEF "LightBlue",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VLIGHTBLUE,	0, 0
	DEF "LightGreen",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VLIGHTGREEN,	0, 0
	DEF "LightCyan",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VLIGHTCYAN,	0, 0
	DEF "LightRed",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VLIGHTRED,	0, 0
	DEF "LightMagenta",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VLIGHTMAGENTA,	0, 0
	DEF "Yellow",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VYELLOW,	0, 0
	DEF "White",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VWHITE,		0, 0
	DEF "GetVideoMode",	0, 0, 0, 0, 0, 0, %(X-1), -1,		GETVIDEOMODE,	0, 1

 
	; Vocabulary FKEYS
	; ----------------
	
	VOC = VOCN_FKEYS

	DEF "Shift-ed",		0, 0, 0, 0, 0, 0, -1,     %(X+1),	SHIFT_ED,	0, 0
	DEF "Ctrl-ed",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CTRL_ED,	0, 0
	DEF "Alt-ed",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ALT_ED,		0, 0
	DEF "KeyPad-ed",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEYPAD_ED,	0, 0

	DEF "KEY_INS",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_INS,	0, 0
	DEF "KEY_DEL",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_DEL,	0, 0
	DEF "KEY_HOME",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_HOME,	0, 0
	DEF "KEY_END",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_END,	0, 0
	DEF "KEY_PGUP",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_PGUP,	0, 0
	DEF "KEY_PGDN",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_PGDN,	0, 0
	DEF "KEY_UP",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_UP,		0, 0
	DEF "KEY_DOWN",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_DOWN,	0, 0
	DEF "KEY_LEFT",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_LEFT,	0, 0
	DEF "KEY_RIGHT",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_RIGHT,	0, 0
	DEF "KEY_ESC",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ESC,	0, 0
	DEF "KEY_+",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_PLUS,	0, 0
	DEF "KEY_-",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_MINUS,	0, 0
 
	DEF "KEY_ALT_A",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_A,	0, 0
	DEF "KEY_ALT_Z",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_Z,	0, 0
	DEF "KEY_ALT_E",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_E,	0, 0
	DEF "KEY_ALT_R",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_R,	0, 0
	DEF "KEY_ALT_T",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_T,	0, 0
	DEF "KEY_ALT_Y",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_Y,	0, 0
	DEF "KEY_ALT_U",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_U,	0, 0
	DEF "KEY_ALT_I",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_I,	0, 0
	DEF "KEY_ALT_O",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_O,	0, 0
	DEF "KEY_ALT_P",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_P,	0, 0
	DEF "KEY_ALT_Q",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_Q,	0, 0
	DEF "KEY_ALT_S",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_S,	0, 0
	DEF "KEY_ALT_D",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_D,	0, 0
	DEF "KEY_ALT_F",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_F,	0, 0
	DEF "KEY_ALT_G",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_G,	0, 0
	DEF "KEY_ALT_H",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_H,	0, 0
	DEF "KEY_ALT_J",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_J,	0, 0
	DEF "KEY_ALT_K",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_K,	0, 0
	DEF "KEY_ALT_L",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_L,	0, 0
	DEF "KEY_ALT_M",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_M,	0, 0
	DEF "KEY_ALT_W",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_W,	0, 0
	DEF "KEY_ALT_X",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_X,	0, 0
	DEF "KEY_ALT_C",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_C,	0, 0
	DEF "KEY_ALT_V",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_V,	0, 0
	DEF "KEY_ALT_B",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_B,	0, 0
	DEF "KEY_ALT_N",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_ALT_N,	0, 0
	
	DEF "KEY_F1",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F1,		0, 0
	DEF "KEY_F2",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F2,		0, 0
	DEF "KEY_F3",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F3,		0, 0
	DEF "KEY_F4",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F4,		0, 0
	DEF "KEY_F5",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F5,		0, 0
	DEF "KEY_F6",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F6,		0, 0
	DEF "KEY_F7",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F7,		0, 0
	DEF "KEY_F8",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F8,		0, 0
	DEF "KEY_F9",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F9,		0, 0
	DEF "KEY_F10",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F10,	0, 0
	DEF "KEY_F11",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	KEY_F11,	0, 0
	DEF "KEY_F12",		0, 0, 0, 0, 0, 0, %(X-1), -1,		KEY_F12,	0, 1


	; Vocabulary SERIAL
	; -----------------
	
	VOC = VOCN_SERIAL
	DEF "SerialOpen",	0, 0, 0, 0, 0, 0, -1,     %(X+1),	SERIALOPEN,	0, 0
	DEF "SerialClose",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALCLOSE,	0, 0
	DEF "NONEPARITY",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	NONEPARITY,	0, 0
	DEF "ODDPARITY",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	ODDPARITY,	0, 0
	DEF "EVENPARITY",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	EVENPARITY,	0, 0
	DEF "SerialParam",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALPARAM,	0, 0
	DEF "SerialIn",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALIN,	0, 0
	DEF "SerialIn?",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALINQ,	0, 0
	DEF "SerialDefPacket",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALDEFPCK,	0, 0
	DEF "SerialPackets?",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALPCKQ,	0, 0
	DEF "SerialPacketRead",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALPCKREAD,	0, 0
	DEF "SerialRead",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALREAD,	0, 0
	DEF "SerialFlushIn",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALFLUSHIN,	0, 0
	DEF "SerialOut",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALOUT,	0, 0
	DEF "SerialWrite",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALWRITE,	0, 0
	DEF "SerialFlushOut",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SERIALFLUSHOUT,	0, 0
	DEF "SerialAbort",	0, 0, 0, 1, 0, 0, %(X-1), -1,		SERIALABORT,	0, 1


	; Vocabulary PORTIO
	; -----------------
	
	VOC = VOCN_PORTIO
	DEF "in",		0, 0, 0, 0, 0, 0, -1,     %(X+1),	INPORT,		0, 0
	DEF "out",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	OUTPORT,	0, 0
	DEF "win",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WINPORT,	0, 0
	DEF "wout",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	WOUTPORT,	0, 0
	DEF "cin",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CINPORT,	0, 0
	DEF "cout",		0, 0, 0, 0, 0, 0, %(X-1), -1,		COUTPORT,	0, 1


	; Vocabulary GRAPHICS
	; -------------------
	
	VOC = VOCN_GRAPHICS
	DEF "#grows",		0, 0, 0, 0, 0, 1, -1,     %(X+1),	GNBROWS,	0, 1
	DEF "#gcols",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GNBCOLS,	0, 1
	DEF "#gcolors",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GNBCOLORS,	0, 1
	DEF "#gpages",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GNBPAGES,	0, 1
	DEF "NOTFILLED",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GNOTFILLED,	0, 0
	DEF "FILLED",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GFILLED,	0, 0
	DEF "clear",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLEAR,		0, 0
	DEF "SelectGPage",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SELECTGPAGE,	0, 0
	DEF "clip",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	CLIP,		0, 0
	DEF "gmode_copy",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GMODE_COPY,	0, 0
	DEF "gmode_xor",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GMODE_XOR,	0, 0
	DEF "gmode_and",	0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GMODE_AND,	0, 0
	DEF "gmode_or",		0, 0, 0, 0, 0, 1, %(X-1), %(X+1),	GMODE_OR,	0, 0
	DEF "SetPixel",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	SETPIXEL,	0, 0
	DEF "GetPixel",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GETPIXEL,	0, 0
	DEF "line",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	LINE,		0, 0
	DEF "hline",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	HLINE,		0, 0
	DEF "vline",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	VLINE,		0, 0
	DEF "box",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	BOX,		0, 0
	DEF "VideoRegion",	1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	VIDEOREGION,	1, 0
	DEF "GetVideo",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	GETVIDEO,	0, 0
	DEF "PutVideo",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	PUTVIDEO,	0, 0
	DEF ">color_sprite",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DEFCOLOR_SPRITE, 0, 0
	DEF ">sprite",		0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DEF_SPRITE,	0, 0
	DEF "sprite",		1, 0, 0, 0, 1, 0, %(X-1), %(X+1),	SPRITE,		1, 0
	DEF "init_sprite",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	INIT_SPRITE,	0, 0
	DEF "draw_sprite",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	DRAW_SPRITE,	0, 0
	DEF "320x200x16",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M320x200x16,	0, 0
	DEF "640x200x16",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M640x200x16,	0, 0
	DEF "640x350x4",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M640x350x4,	0, 0
	DEF "640x350x16",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M640x350x16,	0, 0
	DEF "640x480x2",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M640x480x2,	0, 0
	DEF "640x480x16",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M640x480x16,	0, 0
	DEF "320x200x256",	0, 0, 0, 0, 0, 0, %(X-1), %(X+1),	M320x200x256,	0, 0
	DEF "800x600x16",	0, 0, 0, 0, 0, 0, %(X-1), -1,		M800x600x16,	0, 1

NIA_END:

	purge	DEF


	; --------------------------
	; Data Directory area (DDIR)
	; --------------------------

DEF	MACRO	Name, Size, WordRef
	IFDEF __MAIN__
		ddirentry <-1, WordRef / size wordentry, Size, 0, 0, 0>
	ENDIF
	Name = X
	X = X + size ddirentry
	ENDM
	
		X = 0

DDIR_BEGIN:
		DEF	D_MAXNBTHREADS,		@WordSize,			N_MAXNBTHREADS
		DEF	D_BASE,			@WordSize,			N__BASE
		DEF	D_DUSTTHRESHOLD,	@WordSize,			N_DUSTTHRESHOLD
		DEF	D_NBPAGES,		@WordSize,			N_NBPAGES
		DEF	D_PAGENB,		@WordSize,			N_PAGENB
		DEF	D_NBROWS,		@WordSize,			N_NBROWS
		DEF	D_NBCOLS,		@WordSize,			N_NBCOLS
		DEF	D_SCREENBCKG,		@WordSize,			N_SCREENBCKG
		DEF	D_QUPDATECURSOR,	@WordSize,			N_QUPDATECURSOR
		DEF	D_QALLOTFAIL,		@WordSize,			N_QALLOTFAIL
		DEF	D_QOK,			@WordSize,			N_QOK
		DEF	D_QSAFE,		@WordSize,			N_QSAFE
		DEF	D_QSPEED,		@WordSize,			N_QSPEED
		DEF	D_QIARITHOVERFLOW	@WordSize,			N_QIARITHOVERFLOW
		DEF	D_QCHAT,		@WordSize,			N_QCHAT
		DEF	D_LANGUAGE,		@WordSize,			N_LANGUAGE

		DEF	D_NULLSTR,		sizestrentry+1,			N_NULLSTR

		DEF	D_GNBROWS,		@WordSize,			N_GNBROWS
		DEF	D_GNBCOLS,		@WordSize,			N_GNBCOLS
		DEF	D_GNBCOLORS,		@WordSize,			N_GNBCOLORS
		DEF	D_GNBPAGES,		@WordSize,			N_GNBPAGES
		
		DEF	D_EDC_SLL,		@WordSize,			N_EDC_SLL
		DEF	D_EDC_SLI,		@WordSize,			N_EDC_SLI
		DEF	D_EDC_TXN,		@WordSize,			N_EDC_TXN
		DEF	D_EDC_TXS,		@WordSize,			N_EDC_TXS
		DEF	D_EDC_HLN,		@WordSize,			N_EDC_HLN
		DEF	D_EDC_HLA,		@WordSize,			N_EDC_HLA
		DEF	D_EDC_HLK,		@WordSize,			N_EDC_HLK
		DEF	D_ED_VIDEOMODE,		@WordSize,			N_ED_VIDEOMODE
		DEF	D_ED_DIR,		sizestrentry+MAXSZFILENAME+1,	N_ED_DIR
		DEF	D_ED_QDIRECTVIDEO,	@WordSize,			N_ED_QDIRECTVIDEO
		DEF	D_ED_QUSETAB,		@WordSize,			N_ED_QUSETAB
		DEF	D_ED_COMMENTFIELD,	@WordSize,			N_ED_COMMENTFIELD
		DEF	D_ED_LINEPOSADJUST,	@WordSize,			N_ED_LINEPOSADJUST
		DEF	D_ED_KEY,		@WordSize,			N_ED_KEY
		
		ifdef __MAIN__
		dd	0					; Mark the end
		endif

DDIR_END:

	purge	DEF
	
