; ----------------------------------------------------------------------+
; FROTH - A forth language implementation on PC - Oliver SINGLA 	!
; 									!
; Module:	HBOX.ASM						!
; 									!
; Description:	Definitions for playing with graphics.			!
; 		(drawing box).						!
; 									!
; List of FROTH definitions defined in this module:			!
;	BOX		BOX						!
; 									!
; ----------------------------------------------------------------------+

		.386p
		jumps
		locals

code32  	segment para public use32
		assume cs:code32, ds:code32, ss:code32

include		pmode.inc				; All externs are defined in there

include		Equ.inc
include		Vars.inc
include		Dict.inc

include		hgr.inc


; ===============================================================
; = BOX								=
; =								=
; = Code for the froth word:	box				=
; =								=
; = Stack:  ( x0 y0 x1 y1 color f --- )				=
; ===============================================================

t_y0		equ	word ptr [ebp - 2]
t_y1		equ	word ptr [ebp - 4]

		align	4
BOX	   	proc

		; --------------
		; Temp variables
		; --------------

		enter	2 * 2, 0


		; ------------------
		; Verify stack frame
		; ------------------
		
		VSTACK	6
		

		; -------------
		; Box operation
		; -------------
		
		; if (y0 > y1)
		;     swap(&y0, &y1);
		mov	eax, PARAM4				; y0
		mov	ebx, PARAM2				; y1
		cmp	eax, ebx
		jle	@@LL1
		mov	PARAM2, eax
		mov	PARAM4, ebx
@@LL1:		

		; if (x0 > x1)
		;     swap(&x0, &x1);
		mov	eax, PARAM5				; x0
		mov	ebx, PARAM3				; x1
		cmp	eax, ebx
		jle	@@LL2
		mov	PARAM3, eax
		mov	PARAM5, ebx
@@LL2:		

		; if (x0 > _g_clipx1 || x1 < _g_clipx0 || y0 > _g_clipy1 || y1 < _g_clipy0)
		;      return;
		mov	eax, PARAM5				; x0
		cmp	ax, [_clip_x1]
		jg	@@Exit
		mov	eax, PARAM3				; x1
		cmp	ax, [_clip_x0]
		jl	@@Exit
		mov	eax, PARAM4				; y0
		cmp	ax, [_clip_y1]
		jg	@@Exit
		mov	eax, PARAM2				; y1
		cmp	ax, [_clip_y0]
		jl	@@Exit

		; Fill flag ?
		cmp	PARAM0, FALSE
		je	@@NoFill
		
		; Fill flag
		; ---------

		; if (y0 < _g_clipy0)
		;     y0 = _g_clipy0;
		movzx	eax, [_clip_y0]
		cmp	eax, PARAM4
		jle	@@LL3
		mov	PARAM4, eax
@@LL3:		
		
		; if (y1 > _g_clipy1)
		;     y1 = _g_clipy1;
		movzx	eax, [_clip_y1]
		cmp	eax, PARAM2
		jge	@@LL4
		mov	PARAM2, eax
@@LL4:

		; if (x0 < _g_clipx0)
		;     x0 = _g_clipx0;
		movzx	eax, [_clip_x0]
		cmp	eax, PARAM5
		jle	@@LL5
		mov	PARAM5, eax
@@LL5:

		; if (x1 > _g_clipx1)
		;     x1 = _g_clipx1;
		movzx	eax, [_clip_x1]
		cmp	eax, PARAM3
		jge	@@LL6
		mov	PARAM3, eax
@@LL6:

		;     for (; y0 <= y1; ++y0)
		;         g_hline (y0, x0, x1, color);

		push	fs
		mov	fs, [_selzero]

		mov	eax, PARAM4					; y0
		mov	[t_y0], ax
		mov	eax, PARAM2					; y1
		mov	[t_y1], ax
@@LL10:		mov	eax, PARAM5					; x0
		push	ax
		mov	bx, [t_y0]					; y
		push	bx
		mov	eax, PARAM3					; x1
		push	ax
		push	bx						; y
		mov	eax, PARAM1					; color
		push	ax
		call	[_line_]
		inc	[t_y0]
		mov	ax, [t_y0]
		cmp	ax, [t_y1]
		jbe	@@LL10
		
		pop	fs
		jmp	@@Exit

@@NoFill:	


		; ----------------
		; Return to caller
		; ----------------

@@Exit:		DISCARD	6
		leave
		ret

E_BOX:
BOX		endp


code32		ends
		end

