
		.386p
		jumps
		locals

code32  	segment para public use32
		assume cs:code32, ds:code32, ss:code32

include		pmode.inc				; All externs are defined in there

include		Equ.inc
include		Vars.inc
include		Dict.inc

include		Compile.inc				; FROTH compiled definitions

		
; ===============================================================
; = BMOVE							=
; =								=
; = Code for the forth word:	BMOVE				=
; =                     	                            	=
; = Stack:	( dest src size --- )				=
; ===============================================================

		align	4
BMOVE		proc

		; Verify stack frame
		VSTACK	3

		; Save regs used
		push	esi edi

		; Get data
		mov	edi, PARAM2			; Destination address
		mov	ecx, PARAM0			; Size of the block to move
		mov	esi, PARAM1			; Source address

		; Check dest addr against bound
		bound	edi, qword ptr DDA_BOUND

		; Choose direction
		cmp	esi, edi
		ja	@@great
		std
;		mov	eax, 1
		lea	ebx, [edi - ecx + 1]		
		lea	esi, [esi + ecx - 1]
		lea	edi, [edi + ecx - 1]
		jmp	@@greatlow
@@great:		cld
;		clr	eax
		lea	ebx, [edi + ecx - 1]
@@greatlow:	bound	ebx, qword ptr DDA_BOUND

;		; Align on multiple of 4
;@@align4:	test	edi, 3
;		jz	@@isAlign4
;		jecxz	@@done
;		movsb
;		dec	ecx
;		jmp	@@align4
;@@isAlign4:

		; Move data
;		shr	ecx, 2
		rep	movsb				; Move the block

		; Restore regs used
@@done:		pop	edi esi

		; Return to caller
		cld
		add	esi, 3 * @WordSize		; Free parameters from the stack
		ret

E_BMOVE:
BMOVE		endp


; ===============================================================
; = PBMOVE							=
; =								=
; = Code for the forth word:	(BMOVE)				=
; =                     	                            	=
; = Stack:	( dest src size --- )				=
; ===============================================================

		align	4
PBMOVE		proc

		; Verify stack frame
		VSTACK	3

		; Save regs used
		push	esi edi

		; Get data
		mov	edi, PARAM2			; Destination address
		mov	ecx, PARAM0			; Size of the block to move
		mov	esi, PARAM1			; Source address

		; Choose direction
		cmp	esi, edi
		ja	@@great
		std
;		mov	eax, 1
		lea	ebx, [edi - ecx + 1]		
		lea	esi, [esi + ecx - 1]
		lea	edi, [edi + ecx - 1]
		jmp	@@greatlow
@@great:		cld
;		clr	eax
		lea	ebx, [edi + ecx - 1]
@@greatlow:	

;		; Align on multiple of 4
;@@align4:	test	edi, 3
;		jz	@@isAlign4
;		jecxz	@@done
;		movsb
;		dec	ecx
;		jmp	@@align4
;@@isAlign4:

		; Move data
;		shr	ecx, 2
		rep	movsb				; Move the block

		; Restore regs used
@@done:		pop	edi esi

		; Return to caller
		cld
		add	esi, 3 * @WordSize		; Free parameters from the stack
		ret

E_PBMOVE:
PBMOVE		endp


; ===============================================================
; = FILL							=
; =								=
; = Code for the forth word:	FILL				=
; =                     	                            	=
; = Stack:	( addr n1 n2 --- )				=
; ===============================================================

		align	4
FILL		proc

		; Verify stack frame
		VSTACK	3

		; Save regs used
		push	edi

		; Get data
		mov	edi, PARAM2			; Destination address
		mov	ecx, PARAM1			; Size of the block to fill
		mov	eax, PARAM0			; Value to store

		; Check dest addr against bound (start)
		bound	edi, qword ptr DDA_BOUND

		; Check dest addr against bound (start)
		lea	ebx, [ecx * @WordSize]
		lea	ebx, [ebx + edi - 1]
		bound	ebx, qword ptr DDA_BOUND

		; Fill data
		cld
		rep	stosd				; Fill the block

		; Restore regs used
@@done:		pop	edi

		; Return to caller
		DISCARD	3				; Free parameters from the stack
		ret

E_FILL:
FILL		endp


; ===============================================================
; = LOGICAL							=
; =                                                 		=
; = Code for the forth word:	LOGICAL				=
; =								=
; = Stack:	( --- )						=
; ==============================================================

		align	4
BOOLEAN		proc

		; ---------------------------------------
		; Define the compilation actions sequence
		; ---------------------------------------
		
		; 1 ALLOT DROP
		IPUSH	1
		SUMMON	RT_ALLOT
		DISCARD	1				; DROP

		; DOES>		(this ends the compilation sequence)
		SUMMON	PDOES
		dd	R_BOOLEAN

		
		; ------------------------------------
		; Define the run-time actions sequence
		; ------------------------------------

RT_BOOLEAN:

		; Return to caller
		ret


E_BOOLEAN:
BOOLEAN		endp


; ===============================================================
; = ILOGICAL							=
; =                                                 		=
; = Code for the forth word:	ILOGICAL			=
; =								=
; = Stack:	( f --- )					=
; ===============================================================

		align	4
IBOOLEAN	proc

		; ---------------------------------------
		; Define the compilation actions sequence
		; ---------------------------------------
		
		; 1 ALLOT !
		IPUSH	1
		SUMMON	RT_ALLOT		; 1 ALLOT
		SUMMON	STORE			; !

		; DOES>		(this ends the compilation sequence)
		SUMMON	PDOES
		dd	R_IBOOLEAN

		
		; ------------------------------------
		; Define the run-time actions sequence
		; ------------------------------------

RT_IBOOLEAN:

		; Return to caller
		ret


E_IBOOLEAN:
IBOOLEAN		endp


; ===============================================================
; = BOOL_FALSESTORE						=
; =                                                 		=
; = Code for the forth word:	BOOL.FALSE!			=
; =								=
; = Stack:	( addr --- )					=
; ===============================================================

		align	4
BOOL_FALSESTORE	proc

		; Verify stack frame
		VSTACK	1

		; Get addr
		mov	eax, PARAM0				; Pop adr

		; Check addr against bound
		bound	eax, qword ptr DDA_BOUND

		; Store value
		mov	byte ptr [eax], FALSE
		DISCARD	1

		; Return to caller
		ret

E_BOOL_FALSESTORE:
BOOL_FALSESTORE	endp


; ===============================================================
; = BOOL_TRUESTORE						=
; =                                                 		=
; = Code for the forth word:	BOOL.TRUE!			=
; =								=
; = Stack:	( addr --- )					=
; ===============================================================

		align	4
BOOL_TRUESTORE	proc

		; Verify stack frame
		VSTACK	1

		; Get addr
		mov	eax, PARAM0				; Pop adr

		; Check addr against bound
		bound	eax, qword ptr DDA_BOUND

		; Store value
		mov	byte ptr [eax], TRUE
		DISCARD	1

		; Return to caller
		ret

E_BOOL_TRUESTORE:
BOOL_TRUESTORE	endp


; ===============================================================
; = BOOL_QFALSE							=
; =                                                 		=
; = Code for the forth word:	BOOL.FALSE?			=
; =								=
; = Stack:	( addr --- f )					=
; ===============================================================

		align	4
BOOL_QFALSE	proc

		; Verify stack frame
		VSTACK	1

		; Get addr
		mov	eax, PARAM0
		
		; Check addr against bound
		bound	eax, qword ptr DDA_BOUND
		
		; Read value then push
		cmp	byte ptr [eax], FALSE
		je	@@false
@@true:		mov	PARAM0, FALSE
		ret
@@false:	mov	PARAM0, TRUE

		; Return to caller
		ret

E_BOOL_QFALSE:
BOOL_QFALSE	endp


; ===============================================================
; = BOOL_QTRUE							=
; =                                                 		=
; = Code for the forth word:	BOOL.TRUE?			=
; =								=
; = Stack:	( addr --- f )					=
; ===============================================================

		align	4
BOOL_QTRUE	proc

		; Verify stack frame
		VSTACK	1

		; Get addr
		mov	eax, PARAM0
		
		; Check addr against bound
		bound	eax, qword ptr DDA_BOUND
		
		; Read value then push
		cmp	byte ptr [eax], FALSE
		je	@@false
@@true:		mov	PARAM0, TRUE
		ret
@@false:	mov	PARAM0, FALSE

		; Return to caller
		ret

E_BOOL_QTRUE:
BOOL_QTRUE	endp


; ===============================================================
; = INTEGER							=
; =                                                 		=
; = Code for the forth word:	INT				=
; =								=
; = Stack:	( --- )						=
; =								=
; = Input stream:	INTEGER var				=
; ===============================================================

		align	4
INTEGER		proc

		; ---------------------------------------
		; Define the compilation actions sequence
		; ---------------------------------------

		; 1 ALLOT DROP
		IPUSH	1
		SUMMON	RT_ALLOT
		DISCARD	1

		; DOES>		(this ends the compilation sequence)
		SUMMON	PDOES
		dd	R_INTEGER

		
		; ------------------------------------
		; Define the run-time actions sequence
		; ------------------------------------

RT_INTEGER:	

		; Return to caller
		ret

E_INTEGER:
INTEGER		endp


; ===============================================================
; = IINTEGER							=
; =                                                 		=
; = Code for the forth word:	IINT				=
; =								=
; = Stack:	( n --- )					=
; =								=
; = Input stream:	n IINT var				=
; ===============================================================

		align	4
IINTEGER		proc

		; ---------------------------------------
		; Define the compilation actions sequence
		; ---------------------------------------

		; Verify stack frame
		VSTACK	1

		; 1 ALLOT !
		IPUSH	1
		SUMMON	RT_ALLOT
		SUMMON	STORE					; !
		
		; DOES>		(this ends the compilation sequence)
		SUMMON	PDOES
		dd	R_IINTEGER

		
		; ------------------------------------
		; Define the run-time actions sequence
		; ------------------------------------

RT_IINTEGER:	

		; Return to caller
		ret


E_IINTEGER:
IINTEGER	endp


; ===============================================================
; = CONST							=
; =                                                 		=
; = Code for the forth word:	CONST				=
; =								=
; = Stack:	( n --- )					=
; =								=
; = Input stream:	n CONST var				=
; ===============================================================

		align	4
CONSTANT		proc

		; ---------------------------------------
		; Define the compilation actions sequence
		; ---------------------------------------

		; Verify stack frame
		VSTACK	1

		; 1 ALLOT !
		IPUSH	1
		SUMMON	RT_ALLOT
		SUMMON	STORE					; !
		
		; DOES>		(this ends the compilation sequence)
		SUMMON	PDOES
		dd	R_CONSTANT


		; ------------------------------------
		; Define the run-time actions sequence
		; ------------------------------------

RT_CONSTANT:

		; @
		SUMMON	AT					; @
		
		; Return to caller
		ret

E_CONSTANT:
CONSTANT		endp


; ===============================================================
; = FreeLocalVar						=
; =                                                 		=
; = Usage							=
; =	Free memory allocated for a word with ALLOT.		=
; ===============================================================

		align	4
FreeLocalVar	proc

		; --------------------------
		; Free each dynamic variable
		; --------------------------

		push	esi		
		mov	eax, [esp + 1*4]		; Return addr is addr of cell where is stored nb of dyn var
		mov	ecx, eax
		add	ecx, @WordSize			; Ptr do start of list
		mov	eax, [eax]			; Nb of dynamic variables to free
		clr	ebx				; Dyn var counter
@@Free:		mov	esi, [ecx]			; Memory block nb
		mov	edx, [esi + ecx]
		cmp	edx, -1
		je	@@Free2				; Memory never allocated ('integer xxx' not executed for ex.)
		SUMMON	UnAllot
		mov	dword ptr [esi + ecx], -1	; Memory is freed
@@Free2:	add	ecx, @WordSize			; Next cell
		inc	ebx
		cmp	bl, al
		jne	@@Free
		pop	esi
		
		
		; ----------------------
		; Skip data in code area
		; ----------------------
		
		mov	[esp], ecx


		; ----------------
		; Return to caller
		; ----------------
		
		ret

E_FreeLocalVar:
FreeLocalVar	endp


; ===============================================================
; = FreeData							=
; =                                                 		=
; = Usage							=
; =	Free memory allocated for a word with ALLOT. Is called	=
; =	only when the word is forgetten.			=
; =								=
; = I) EDX : word NIA address					=
; =								=
; = M) none							=
; ===============================================================

		align	4
FreeData	proc

		; -------------------
		; Save used registers
		; -------------------
		
		push	eax ebx ecx edx esi
		

		; -----------
		; Get word nb
		; -----------
		
		sub	edx, [NIA_START]

		
		; -----------------------------------------------
		; Found each memory block allocated for this word
		; -----------------------------------------------

		; Find last record freed (linked list)
		mov	esi, [DDIR_FFREED]
		cmp	esi, -1
		je	@@LL2
@@LL1:		add	esi, [DDIR_START]
		cmp	[esi.ddir_NextFreed], -1
		je	@@LL3
		mov	esi, [esi.ddir_NextFreed]
		jmp	@@LL1
@@LL2:		clr	esi
@@LL3:		

		; Initializations		
		mov	ecx, edi				; EDI = [DDIR_START]
		mov	ebx, ecx
		add	ebx, [DDIR_SIZE]
		
		; End of table ?
@@TestBlock:	cmp	ecx, ebx
		je	@@Done
		
		; First record freed ?
		cmp	ecx, esi
		je	@@NextBlock

		; Record freed ?
		cmp	[ecx.ddir_NextFreed], -1
		jne	@@NextBlock
		
		; Test this memory block
		movzx	eax, [ecx.ddir_wordnb]
		imul	eax, size wordentry
		cmp	eax, edx
		jne	@@NextBlock
	
		; Free this block
		push	edx
		mov	edx, ecx
		sub	edx, edi				; EDI = [DDIR_START]
		SUMMON	UnAllot
		pop	edx
		
		; Next ddir block to test
@@NextBlock:	add	ecx, size ddirentry
		jmp	@@TestBlock
		
@@Done:

		; ----------------
		; Return to caller
		; ----------------

@@Exit:		pop	esi edx ecx ebx eax
		ret

FreeData	endp


; ===============================================================
; = DiscardLocalVars						=
; =                                                 		=
; = Usage							=
; =	Discard all local variables. Called by 'doError'.	=
; =								=
; = I) none							=
; = O) none							=
; = M) none							=
; ===============================================================

		align	4
DiscardLocalVars proc

		; --------------------------------
		; Scan each memory block allocated
		; --------------------------------

		; Find last record freed (linked list)
		push	ebx ecx edx
		mov	ebx, [DDIR_FFREED]
		cmp	ebx, -1
		je	@@LL2
@@LL1:		add	ebx, [DDIR_START]
		cmp	[ebx.ddir_NextFreed], -1
		je	@@LL3
		mov	ebx, [ebx.ddir_NextFreed]
		jmp	@@LL1
@@LL2:		clr	ebx
@@LL3:		

		; Initializations		
		mov	ecx, [DDIR_START]
		add	ecx, [DDIR_SIZE]
		
		; Next ddir block to test
		; End of table ?
@@NextBlock:	
		sub	ecx, size ddirentry
@@NextBlock2:	cmp	ecx, [DDIR_START]
		je	@@Done

		; First record freed ?
		cmp	ecx, ebx
		je	@@NextBlock

		; Record freed ?
		cmp	[ecx.ddir_NextFreed], -1
		jne	@@NextBlock
		
		; Test this memory block: is-it an automatic variable ?
		test	[ecx.ddir_flags], QDATA_AUTO
		jz	@@NextBlock

		; Free this block
		mov	edx, ecx
		sub	edx, [DDIR_START]
		call	UnAllot
		
		; Next ddir block to test
		jmp	@@NextBlock
		
@@Done:

		; ----------------
		; Return to caller
		; ----------------

@@Exit:		pop	edx ecx ebx
		ret

DiscardLocalVars endp


; ===============================================================
; = DiscardThreadLVars						=
; =                                                 		=
; = Usage							=
; =	Discard all local variables, for a given thread.	=
; =	Called by 'ENDTHREAD'					=
; =								=
; = I) EAX : thread nb						=
; = O) none							=
; = M) EBX ECX EDX						=
; ===============================================================

		align	4
DiscardThreadLVar proc

		; --------------------------------
		; Scan each memory block allocated
		; --------------------------------

		; Find last record freed (linked list)
		push	ebx ecx edx
		mov	ebx, [DDIR_FFREED]
		cmp	ebx, -1
		je	@@LL2
@@LL1:		add	ebx, [DDIR_START]
		cmp	[ebx.ddir_NextFreed], -1
		je	@@LL3
		mov	ebx, [ebx.ddir_NextFreed]
		jmp	@@LL1
@@LL2:		clr	ebx
@@LL3:		

		; Initializations		
		mov	ecx, edi					; EDI = [DDIR_START]
		add	ecx, [DDIR_SIZE]
		
		; End of table ?
@@TestBlock:	cmp	ecx, edi
		je	@@Done
		sub	ecx, size ddirentry

		; First record freed ?
		cmp	ecx, ebx
		je	@@NextBlock

		; Record freed ?
		cmp	[ecx.ddir_NextFreed], -1
		jne	@@NextBlock
		
		; Test this memory block
		test	[ecx.ddir_flags], QDATA_AUTO
		jz	@@NextBlock				; No automatic variable
		cmp	al, [ecx.ddir_threadnb]			; Thread nb
		jne	@@NextBlock
	
		; Free this block
		mov	edx, ecx
		sub	edx, edi					; EDI = [DDIR_START]
		SUMMON	UnAllot
		
		; Next ddir block to test
@@NextBlock:	jmp	@@TestBlock
		
@@Done:

		; ----------------
		; Return to caller
		; ----------------

@@Exit:		pop	edx ecx ebx
		ret

DiscardThreadLVar endp


code32		ends
		end
