; ----------------------------------------------------------------------+
; FROTH - A forth language implementation on PC - Oliver SINGLA 	!
; 									!
; Module:	VARS.INC						!
; 									!
; Description:	All public variables used (and also error msg).		!
; 									!
; ----------------------------------------------------------------------+

IFDEF	__MAIN__


		; ----------------
		; ARG cmd line msg
		; ----------------

		align	4
ArgMsg		db	13, 10
		db	"FROTH v"
		db	FROTH_VERSION + '0', '.', (FROTH_RELEASE/10) + '0', (FROTH_RELEASE MOD 10) + '0', '.', FROTH_UNDERREL + 'a', " "
		db	(FROTH_DATE_MONTH / 10) + '0', (FROTH_DATE_MONTH mod 10) + '0', '-'
		db	(FROTH_DATE_DAY   / 10) + '0', (FROTH_DATE_DAY   mod 10) + '0', '-'
		db	(FROTH_DATE_YEAR  / 10) + '0', (FROTH_DATE_YEAR  mod 10) + '0'
		db	"  written by Oliver SINGLA   *Public domain*", 13, 10
		db	13, 10
		db	"~~ This is an experimental version, still and always under development.", 13, 10
		db	"~~ See MANUAL.FRM about the manual.", 13, 10
		db	"~~ Author email: singla@email.teaser.fr", 13, 10
		db	13, 10
		db	"   Syntax: froth [-?] [-eX] [-sX] [-tX]", 13, 10
		db	"Arguments: -?   give this help", 13, 10
		db	"           -eX  (X is a decimal nb), fix the size (in Kb) of editor buffers", 13, 10
		db	"           -sX  (X is a decimal nb), fix the size (in Kb) of the scrap", 13, 10
		db	"           -tX  (X is a decimal nb), fix the size (in Kb) of the trace manager", 13, 10
		db	"                buffer", 13, 10
		db	13, 10
		db	"Don't forget the online help: USE word", 13, 10
		db	"Help using editor FROSTED: 5 (numeric keyboard)", 13, 10
		db	13, 10
		db	0


		; ------------
		; System stack
		; ------------
	
		align	4
SStackStart	dd	MAXNB_THREADS dup (?)


		; ----------------------
		; Ctrl-break nested flag
		; ----------------------

		align	4
NoCtrlBreak	dd	?
CtrlBreakEvent	db	?


		; --------
		; Keyboard
		; --------

		align	4
KbdTable	kbentry	KB_MAXNBRECORDS+1 dup (<>)		; Keyboard table


		; --------
		; Threads
		; --------

		align	4
ActiveThreadsNb	dd	?					; Nb of active threads
CurrActThread	dd	?					; Current active thread
ThreadsActive	db	MAXNB_THREADS dup (?)			; Is each thread active ?
		align	4
ThreadsESP	dd	MAXNB_THREADS dup (?)			; Save ESP for each thread
		align	4
ThreadsIP	dd	MAXNB_THREADS dup (?)			; Save IP for each thread
		align	4
ThreadsFSP	dd	MAXNB_THREADS dup (?)			; Save FROTH STACK POINTER (ESI) for each thread
		align	4
Threads1stPass	db	MAXNB_THREADS dup (?)			; First passage ?
		

		; -----------------------------
		; Start of the parameters stack
		; -----------------------------
		
		align	4
PStackStart	dd	MAXNB_THREADS dup (?)


		; ------------------------------------
		; Start of the second parameters stack
		; ------------------------------------
		
		align	4
RStackStart	dd	MAXNB_THREADS dup (?)
		align	4
RStackPtr	dd	MAXNB_THREADS dup (?)


		; ---------------
		; Vocabulary area
		; ---------------
		
		align	4
VOC_START	dd	?					; Start of vocab area
VOC_CURRENT	dd	?					; Pointer to the vocabulary to which words are currently being appened
VOC_CONTEXT	dd	?					; Pointer to the vocabulary that is to be searched first
VOC_NB		dd	?					; Nb of vocabulary defined


		; --------------------
		; NIA : Name Info Area
		; --------------------
		
		align	4
NIA_START	dd	?				; Start of NIA
NIA_SIZE	dd	?				; Actual size of NIA


		; --------------------
		; Code Dict Area (CDA)
		; --------------------
		
		align	4
CDA_START	dd	?			; Starting address of Code Dict Area
CDA_SIZE	dd	?			; Actual size of CDA	
CDA_SIZE_INIT	dd	?			; Initial size of CDA (on start)
CompileMode	db	?			; TRUE: system is in mode compilation  FALSE: mode immediate
LastWordDefWColon dd	?			; Last word (NIA) defined with : (colon)
		align	4
CDA_COMMENT	db	?			; Comment level (0 = not inside a comment)
		align	4
CDA_SLASHSLASH	db	?			; Comment to end of line ?
		align	4
CDA_CURR_WORD	dd	?			; Save NIA address of current word (see 'CreateLocal')
CDA_BRACKET_MODE db	?			; Store directly code op into word ?
		align	4
CDA_BUILD_CALLED db	?			; Is 'BUILD>' called ?
		align	4
CDA_DOES_CALLED	db	?			; Is 'DOES>' called ?
		align	4
CDA_ALLOT_CALLED db	?			; Is 'ALLOT' called ?
		align	4
REF_BLK_ALLCTED	dd	?			; Last block allocated (used by ALLOT and ,), else -1
InfixExprEvalQ	db	?			; Infixed expression evaluation ?


		; ----------------
		; Make .EXE status
		; ----------------

		align	4
ExeTag		db	"OlSiCPHC"
		align	4
ExeFile		db	FALSE			; Are-we executing a saved file.exe ?
		align	4
ExeWordAddr	dd	?			; Address of the word to execute
ExeCdaBegin	dd	?			; Adress of user's code into .EXE file
ExeCdaSize	dd	?			; Size of user's code
ExeDdaBegin	dd	?			; Adress of user's data into .EXE file
ExeDdaSize	dd	?			; Size of user's data
OfsDictReloc	dd	?			; Offset of code dict relocation
Exe2ndPass	db	FALSE			; 2nd pass (see Quit) ?


		; ---------------------
		; Local Dict Area (LDA)
		; ---------------------

		align	4
LDA_START	dd	?				; Starting address
LDA_SIZE	dd	?				; Actual size of LDA


		; --------------------------
		; Data Directory area (DDIR)
		; --------------------------
		
		align	4
DDIR_START	dd	?				; Start of data dir area
DDIR_SIZE	dd	?				; Actual size of the data dir area
DDIR_SIZE_INIT	dd	?				; Initial size of DDIR (on start)
DDIR_FFREED	dd	?				; 1st record freed, or -1 if none
DDIR_MEMSALV	dd	?				; Memory which can be recovered with GARBAGE (see: DataSalvage)
		

		; --------------------
		; Data Dict Area (DDA)
		; --------------------
		
		align	4
DDA_START	dd	?				; Starting address of Data Dict Area
DDA_SIZE	dd	?				; Actual size of DDA
DDA_SIZE_INIT	dd	?				; Initial size of DDA (on start)
DDA_BOUND	dd	2 dup (?)			; Used for bound
DynamicFlag	db	?				; Flag: DYNAMIC word called ?
		align	4
AllocFlag	db	?				; Flag: ALLOC called ?
		align	4
AllocFound	db	?				; Flag: ALLOC found (while compiling) ?
		align	4
FreeFlag	db	?				; Flag: FREE called ?
		align	4
FreeFound	db	?				; Flag: FREE found (while compiling) ?
		align	4
DynVarAddr	dd	?				; Address of beginning for dynamic variable


		; ----------------------
		; Cross words references
		; ----------------------

		align	4
CrossRefNb	dd	?				; Nb of words references defined
CrossRefTotalNb	dd	?				; Nb total of records used
CrossRef	dd	?				; Table of all words references
CrossRefFFreed	dd	?				; First record freed
CRefNdxRefRD	dd	?				; Index on couple (callers, calleds)
CRefNdxRefDR	dd	?				; Index on couple (calleds, callers)


		; -----------------------------------------------------
		; Does 'STARTUP.FTH' loaded ? Does Editor initialized ?
		; -----------------------------------------------------
		
		align	4
StartupLoaded	db	FALSE					; 'STARTUP.FTH' loaded ?
		align	4
GreatingMsgPr	db	FALSE					; Greating msg printed ?


		; ------------
		; Input buffer
		; ------------

		align	4
INPUTBUFF	db	IBUFFMAXS+1 dup (?)		; Input buffer
		align	4
IBUFFLEN	dd	? 				; Length of data into input buffer
IBUFFPTR	dd	?				; Current pointer into the buffer (see INTERPRET and CREATE)
IBUFFPTR2	dd	?				; Current pointer into the buffer (end of word)
QuoteStrBuff	dd	?				; Buffer in low memory, to hold literal string
LoadFilesNb	dd	?				; Level of files which are loaded (0 means input stream is terminal)
LoadFilesInfos	dd	?				; Array of handles of files which are loaded ("load)


		; ---------------------------
		; Numeric output buffer (NOB)
		; ---------------------------

		align	4
		db	size strentry + NOBMAXSZ + 1 dup (?)	; Buffer
NOB:
		align	4
NOBPTR		dd	?					; Pointer into NOB
NegFlag		db	?					; Minus indicator ?


		; ---------
		; WordName$
		; ---------

		align	4
WordNameBuff	db	size strentry + WORDMAXLEN + 1 dup (?)	; String header + buffer


		; -----------
		; Word buffer
		; -----------

		align	4
WORDBUFF	db	WBUFFMAXS+1 dup (?)			; Word buffer
		align	4
WBUFFLEN	dd	? 					; Length of the word


		; ---------
		; HELP file
		; ---------

		align	4
HelpFileName	db	HELP_FILENAME, 0
		align	4
HelpFileHdl	dw	?
		align	4
HelpDir		dd	?				; Help words directory (loaded in memory)
		align	4
HelpBuff	dd	?				; Buffer for the help of a given word

ifdef UNDERDEV
		align	4
LstWordsFileN	db	WORDSLIST_FILENAME, 0
endif


		; -------------
		; TRACE manager
		; -------------
		
		align	4
TraceBuffer	dd	?				; Trace manager buffer address		
TraceBufferMaxSz dd	?				; Max size of this buffer
		

		; -----------------------------------------------------
		; Control structures stack, used only at compile time !
		; -----------------------------------------------------

		align	4
ControlStack0:	dd	CONTROLSTACKSZ*2 dup (?)
ControlStack:
		align	4
ControlStackPtr	dd	?					; Control stack pointer


		; -----------------------------------------------
		; Loop stack, used only at run time
		; Note: there is a separate stack for each thread
		; -----------------------------------------------
		
		align	4
LoopStackNb	dd		MAXNB_THREADS dup (?)			; Nb of loops actives (stacked)
		align	4
LoopStack	loopentry	LOOPSTACKMAXNB * MAXNB_THREADS dup (<>)	; The loop stack

	
		; ----------
		; Case stack
		; ----------

		align	4
CaseStackNb	dd	MAXNB_THREADS dup (?)				; Nb of nested case..endcase
CaseStack	dd	CASESTACKMAXNB * MAXNB_THREADS dup (?)		; The case stack


		; ---------------------------------------------------------------
		; READ/WRITE data greater than 64k or above 1Mb into MS/DOS files
		; ---------------------------------------------------------------
	
		align	4
FileIOBuff	dd	?						; File IO Buffer address


		; -----------------------------
		; Last file IO operation status
		; -----------------------------

		align	4
FileIOStatus	dw	?


		; ------------------------
		; Buffer for AskVideoInfos
		; ------------------------

		align	4
AskVideoInfBuff	dd	?
		
	
		; ---------------------------------------------
		; Power of base, for ascii -> binary conversion
		; ---------------------------------------------

		align	4
POWER		MACRO	Base, Nb
		X = 1
		dd	1
		rept	Nb-1
		X = X * Base
		dd	X
		endm
		dd	0
		ENDM

@@PW2:		POWER	 2, 31
@@PW3:		POWER	 3, 20
@@PW4:		POWER	 4, 16
@@PW5:		POWER	 5, 14
@@PW6:		POWER	 6, 12
@@PW7:		POWER	 7, 12
@@PW8:		POWER	 8, 11
@@PW9:		POWER	 9, 11
@@PW10:		POWER	10, 10
@@PW11:		POWER	11, 10
@@PW12:		POWER	12, 9
@@PW13:		POWER	13, 9
@@PW14:		POWER	14, 9
@@PW15:		POWER	15, 8
@@PW16:		POWER	16, 8
@@PW17:		POWER	17, 8
@@PW18:		POWER	18, 8
@@PW19:		POWER	19, 8
@@PW20:		POWER	20, 8
@@PW21:		POWER	21, 8
@@PW22:		POWER	22, 7
@@PW23:		POWER	23, 7
@@PW24:		POWER	24, 7
@@PW25:		POWER	25, 7
@@PW26:		POWER	26, 7

POWERTAB	dd	@@PW2,  @@PW3,  @@PW4,  @@PW5,  @@PW6,  @@PW7,  @@PW8,  @@PW9,  @@PW10
		dd	@@PW11, @@PW12, @@PW13, @@PW14, @@PW15, @@PW16, @@PW17, @@PW18, @@PW19
		dd	@@PW20, @@PW21, @@PW22, @@PW23, @@PW24, @@PW25, @@PW26
		

; ----------------------------------
; ---> Variables for module: KBD.ASM

		align	4
KbdItInstalled	db	FALSE					; Is own handler installed ?

		align	4
OldProtMIrq1	dd	?					; Saved old protected mode irq #1 vector
OldRealMIrq1	dd	?					; Saved old real mode irq #1 vector

		align	4
TwoSeq		db	?					; $E0 sequence ?
		align	4
FIFO		dw	KB_FIFOSZ*2 dup (?)			; FIFO
		align	4
FIFO_CharsNb	dd	?					; Nb of chars available into the FIFO
FIFO_head	dd	?					; Head pointer into FIFO
FIFO_tail	dd	?					; Tail pointer into FIFO
ShiftState	db	?					; Flag (0 | 1 | 2): is a key SHIFT held ?
		align	4
CtrlState	db	?					; Flag (0 | 1 | 2): is a key CTRL held ?
		align	4
AltState	db	?					; Flag (0 | 1 | 2): is a key ALT held ?
		align	4
ScanStates	db	KB_MAXNBRECORDS dup (?)			; State of each key (scan code is the indice of this array)
		align	4
kbrmirqbuff	db	21 dup (?)				; Stubb for real interrupt (see pmode.asm)


; <--- End of static variables, locals to this module <--- 
; --------------------------------------------------------

endif
	

		; -----------------------
		; Index for function keys
		; -----------------------

ikey		MACRO	iname, sname
		global	IK_&iname:	dword
		ifdef __MAIN__
			IK_&iname	dd	0				; Index into 'KbdTable'
					db	sname, 0
		endif
		endm

		align	4
		ikey	INS,		"INS"
		ikey	DEL,		"DEL"
		ikey	HOME,		"HOME"
		ikey	END,		"END"
		ikey	PGUP,		"PGUP"
		ikey	PGDN,		"PGDN"
		ikey	UP,		"UP"
		ikey	DOWN,		"DOWN"
		ikey	LEFT,		"LEFT"
		ikey	RIGHT,		"RIGHT"
		ikey	ESC,		"ESC"
		ikey	PLUS,		"N-+"
		ikey	MINUS,		"N--"

		ikey	F1,		"F1"
		ikey	F2,		"F2"
		ikey	F3,		"F3"
		ikey	F4,		"F4"
		ikey	F5,		"F5"
		ikey	F6,		"F6"
		ikey	F7,		"F7"
		ikey	F8,		"F8"
		ikey	F9,		"F9"
		ikey	F10,		"F10"
		ikey	F11,		"F11"
		ikey	F12,		"F12"
		
		ikey	ALT_A,		"A"
		ikey	ALT_Z,		"Z"
		ikey	ALT_E,		"E"
		ikey	ALT_R,		"R"
		ikey	ALT_T,		"T"
		ikey	ALT_Y,		"Y"
		ikey	ALT_U,		"U"
		ikey	ALT_I,		"I"
		ikey	ALT_O,		"O"
		ikey	ALT_P,		"P"
		ikey	ALT_Q,		"Q"
		ikey	ALT_S,		"S"
		ikey	ALT_D,		"D"
		ikey	ALT_F,		"F"
		ikey	ALT_G,		"G"
		ikey	ALT_H,		"H"
		ikey	ALT_J,		"J"
		ikey	ALT_K,		"K"
		ikey	ALT_L,		"L"
		ikey	ALT_M,		"M"
		ikey	ALT_W,		"W"
		ikey	ALT_X,		"X"
		ikey	ALT_C,		"C"
		ikey	ALT_V,		"V"
		ikey	ALT_B,		"B"
		ikey	ALT_N,		"N"
		
		ifdef	__MAIN__
			dd	-1
		endif

		purge	ikey


		; ---------------
		; Error Msg codes
		; ---------------

MSG		MACRO	code, msg
		X	=	X+1
		code	=	X
		ifdef __MAIN__
			db	code
			db	msg
			db	0
		endif
		ENDM

IFDEF	__MAIN__
ERRMSG:
ENDIF
		align	4
		X = 0

		MSG	ERR_CTRLBREAK,		"Ctrl-Break."
		
		MSG	ERR_EXCP_0,		"Division by zero or quotient too large (not 32-bits)."
		MSG	ERR_EXCP_1,		"Interrupt 1 (step by step)."
		MSG	ERR_EXCP_2,		"Interrupt 2 (NMI, memory error)."
		MSG	ERR_EXCP_3,		"Interrupt 3 (break stop)."
		MSG	ERR_EXCP_4,		"Integer arithmetic overflow."
		MSG	ERR_EXCP_5,		"Memory exception."
		MSG	ERR_EXCP_6,		"Illegal 386 code operation."
		MSG	ERR_EXCP_7,		"Interrupt 7 (arith coprocessor not available)."
		MSG	ERR_EXCP_8,		"Interrupt 8."
		MSG	ERR_EXCP_9,		"Interrupt 9."
		MSG	ERR_EXCP_A,		"Interrupt A."
		MSG	ERR_EXCP_B,		"Interrupt B."
		MSG	ERR_EXCP_C,		"Interrupt C (Stack error)."
		MSG	ERR_EXCP_D,		"Interrupt D."
		MSG	ERR_EXCP_E,		"Interrupt E."
		MSG	ERR_EXCP_F,		"Interrupt F."

		MSG	ERR_BADKBFRMT,		"Bad keyboard file format."
		MSG	ERR_NOTHLPFILE,		"File '\FROTH\FROTH.HLP' not found."
		MSG	ERR_WNFNAN,		"Word not found and not a number."
		MSG	ERR_NULLWORD,		"No word name was specified."
		MSG	ERR_BADWORDNAME,	"Invalid word name."
		MSG	ERR_NOTREDEFWORD,	"Cannot redefine a word."
		MSG	ERR_NOTREDEFNUMBER,	"Cannot redefine a number."
		MSG	ERR_NOTINCOMP,		"System must be in compile state, not execute state."
		MSG	ERR_NOTINEXEC,		"System must be in execute state, not compile state."
		MSG	ERR_NOTLOADED,		"Cannot be compiled from a loaded file."
		MSG	ERR_FORGETSEMIC,	"Still in compile state (missing ;)."
		MSG	ERR_RTWCANTBECOMPILED,	"Run time words can't be compiled inside user definitions."
		MSG	ERR_RTWCANTBEEXECUTED,	"Run time words can't be run in execute state."
		MSG	ERR_CANTBECOMPILED,	"This system word can't be compiled inside user definitions."

		MSG	ERR_COMPILENOTIMMW,	"'COMPILE' can be used only with immediate words."
		MSG	ERR_BUILDALCALLED,	"'BUILD>' has been already called."
		MSG	ERR_DOESALCALLED,	"'DOES>' has been already called."
		MSG	ERR_ALLOTALCALLED,	"'ALLOT' has been already called."
		MSG	ERR_BUILDNOTFIRST,	"'BUILD>' must be the 1st definition compiled."
		MSG	ERR_BUILDNOTCALLED,	"'BUILD>' not called beforehand."
		MSG	ERR_DOESNOTCALLED,	"'DOES>' not called beforehand."
		MSG	ERR_ALLOTNOTCALLED,	"'ALLOT' not called beforehand."
		MSG	ERR_BUILDDOESINC,	"'BUILD> ... ALLOT ... DOES>' construction is incorrect."
		MSG	ERR_ALLOTMOREBAD,	"'ALLOTMORE' can be used only after ALLOT (non dynamic)."
		MSG	ERR_NOMEMORY,		"Allot failed: out of memory."
		MSG	ERR_DDIRFULL,		"Data allocation table full."
		MSG	ERR_DYNAALCALL,		"DYNAMIC word already called."
		MSG	ERR_ALLOCALCALL,	"ALLOC word already called."
		MSG	ERR_DYNVARNOTALL,	"Dynamic variable not allocated."
		MSG	ERR_DYNVARALALL,	"Dynamic variable already allocated."
		MSG	ERR_ALLOCANOTDYNVAR,	"Try to allocate a not dynamic variable."
		
		MSG	ERR_BRACKETALOPEN,	"[: mode already open."
		MSG	ERR_BRACKETNOTOPEN,	"[: mode not open."
		MSG	ERR_BRACKETNOTCLOSED,	"[: mode is not closed."
		MSG	ERR_NOTNBBRACKMODE,	"Not a valid hexadecimal number in [: :] mode."
		
		MSG	ERR_LWORDALDEFIN,	"Automatic word already defined."
		MSG	ERR_TOOMANYLWORDS,	"Too many automatic words defined."
		MSG	ERR_LWORDNOTUSED,	"Automatic word defined but bot used !"
		
		MSG	ERR_BADCOMM,		"Bad right comment sign (lacks left sign: ')')."
		MSG	ERR_LACKQUOTE,		'End quote lacking (").'

		MSG	ERR_FILENF,		"DOS filesystem -> File not found."
		MSG	ERR_PATHNF,		"DOS filesystem -> Path not found."
		MSG	ERR_TOOMANYOF,		"DOS filesystem -> Too many open files."
		MSG	ERR_ACCDENIED,		"DOS filesystem -> Access denied."

		MSG	ERR_BEGINNC,		"'BEGIN' not called beforehand."
		MSG	ERR_IFNC,		"'IF' not called beforehand."
		MSG	ERR_TIMESNC,		"'TIMES' not called beforehand."
		MSG	ERR_DONC,		"'DO' not called beforehand."
		MSG	ERR_MAKENC,		"''MAKE' not called beforehand."
		MSG	ERR_WHILENC,		"'WHILE' not called beforehand."
		MSG	ERR_CASENC,		"'CASE' not called beforehand."
		MSG	ERR_OFNC,		"'OF' not called beforehand."
		
		MSG	ERR_TOOMANYCTRL,	"Too many nested control structures."
		MSG	ERR_BEGINNEND,		"BEGIN... structure not ended."
		MSG	ERR_WHILENEND,		"BEGIN...WHILE...REPEAT structure not endded."
		MSG	ERR_IFNEND,		"IF...ELSE...ENDIF structure not ended."
		MSG	ERR_TIMESNEND,		"TIMES...ENDTIMES structure not ended."
		MSG	ERR_TOOMANYLOOPS,	"Too many nested loops control structures."
		MSG	ERR_DONEND,		"DO...ENDDO structure not ended."
		MSG	ERR_MAKENEND,		"MAKE...ENDMAKE structure not ended."
		MSG	ERR_DOWHENNEND,		"DO...(NOT)WHEN...ENDDO or LOOP...(NOT)WHEN...ENDLOOP structure not ended."
		MSG	ERR_BADLOOPIND,		"Bad loop indice."
		MSG	ERR_CASENEND,		"CASE...ENDCASE structure not ended."
		MSG	ERR_TOOMANYCASES,	"Too many nested cases control structures."
		MSG	ERR_OFNEND,		"CASE...OF..ENDOF...ENDCASE structure not ended."
		
		MSG	ERR_EDFILENG,		"FROSTED main file not specified."
		MSG	ERR_VOCALRDEFW,		"Already defined as word, cannot be redefined as vocabulary."
		MSG	ERR_VOCALRDEFV,		"Already defined as vocabulary."
		MSG	ERR_VOCTBLFULL,		"Vocabulary table full."
		MSG	ERR_WORDNDEF,		"Word not defined."
		MSG	ERR_WORDISUSED,		"Word is used, can't be forgotten."
		MSG	ERR_WORDSYSTEM,		"This word can't be forgotten."
		MSG	ERR_VOCNFORG,		"This vocabulary can't be forgotten (not son of context)."
		MSG	ERR_WORDHLPNSYS,	"No help available on user words."
		MSG	ERR_HELPNOTAVAIL,	"Help not available for this word."

		MSG	ERR_STACKUNDERFLOW,	"Stack -> underflow."
		MSG	ERR_STACKOVERFLOW,	"Stack -> overflow."
		MSG	ERR_RSTACKUNDERFLOW,	"Second stack -> underflow."
		MSG	ERR_RSTACKOVERFLOW,	"Second stack -> overflow."

		MSG	ERR_BADWORDHEADER,	"Invalid word header, can't update callers/calleds."
		MSG	ERR_QENOUGHTNOTCSTG,	"An integer constant must be compiled before ?ENOUGHT"
		MSG	ERR_BADARRAYINDICE,	"Bad array indice."
		MSG	ERR_CONSTINTOUTOFRANGE,	"Constant integer out of range."

		MSG	ERR_DEFERNOTDEF,	"Deferred word not set (pointer to ?)."

		MSG	ERR_NOTASTRING,		"Not a string (invalid string header)"
		MSG	ERR_INVHEXNBSTR,	"Invalid hexadecimal number given in a string (\xx)."
		MSG	ERR_STRINGOVERFLOW,	"String overflow."
		MSG	ERR_STRCOPYAFTEREND,	"Copy after the end of the destination string."
		MSG	ERR_DOTDYNAMICSTRING,	"Not a dynamic string."
		MSG	ERR_DYNASTRNOTLOC,	"A dynamic string cannot be created as local (automatic)."
		MSG	ERR_DYNASTRNOTDYN,	"A dynamic string cannot be used with the words DYNAMIC / ALLOC / FREE."
		
		MSG	ERR_BRACENOTCLOSED,	"Infixed expr. evaluation -> { ... } mode not closed."
		MSG	ERR_NOTALLOWINBRACEM,	"Infixed expr. evaluation -> word not callable under this mode."
		MSG	ERR_BRACERPARENTHBAD,	"Infixed expr. evaluation -> incorrect closing parenthesis."
		MSG	ERR_BRACESTACKFULL,	"Infixed expr. evaluation -> internal stack overflow."
		MSG	ERR_BRACEOPERATOREXPEC,	"Infixed expr. evaluation -> operator expected, number given."
		MSG	ERR_BRACENEEDRIGHTPAR,	"Infixed expr. evaluation -> need right parenthesis."
		MSG	ERR_BRACESYNTAXERROR,	"Infixed expr. evaluation -> syntax error."
		
		MSG	ERR_FROTHEXENOTFOUND,	"SAVE.EXE -> FROTH.EXE file not found."
		MSG	ERR_FROTHEXENOUWORDS,	"SAVE.EXE -> Nothing to save !"

		MSG	ERR_GMODENOTSET,	"Graphics mode not set."
		
		MSG	ERR_INVPARAMS,		"Invalid parameters."
		
		MSG	ERR_SPRITEINVSTRLEN,	"SPRITE -> Invalid defining string length (not equal to sprite width)."
		MSG	ERR_SPRITEINVCHAR,	"SPRITE -> Character not defined."
		MSG	ERR_SPRITENOTA,		"SPRITE -> Not a sprite."
		MSG	ERR_SPRITENOTINIT,	"SPRITE -> Not initialized."
		
		MSG	ERR_NOTYETAVAIL,	"Sorry, this function is not yet implemented. Next release..."

		db	0

global	ArgMsg:			byte
		
global	NoCtrlBreak:		dword
global	CtrlBreakEvent:		byte

global	KbdTable:		kbentry:	KB_MAXNBRECORDS+1

global	ActiveThreadsNb:	dword
global	CurrActThread:		dword
global	ThreadsActive:		byte:		MAXNB_THREADS
global	ThreadsESP:		dword:		MAXNB_THREADS
global	ThreadsIP:		dword:		MAXNB_THREADS
global	ThreadsFSP:		dword:		MAXNB_THREADS
global	Threads1stPass:		byte:		MAXNB_THREADS

global	SStackStart:		dword:		MAXNB_THREADS

global	PStackStart:		dword:		MAXNB_THREADS

global	RStackStart:		dword:		MAXNB_THREADS
global	RStackPtr:		dword:		MAXNB_THREADS

global	INPUTBUFF:		byte:		IBUFFMAXS+1
global	IBUFFLEN:		dword
global	IBUFFPTR:		dword
global	IBUFFPTR2:		dword
global	QuoteStrBuff:		dword
global	LoadFilesNb:		dword
global	LoadFilesInfos:		dword

global	NOB:			near
global	NOBPTR:			dword
global	NegFlag:		byte

global	WordNameBuff:		byte:		size strentry + WORDMAXLEN + 1

global	WORDBUFF:		byte:		WBUFFMAXS+1
global	WBUFFLEN:		dword

global	HelpFileName:		byte
global	HelpFileHdl:		word
global	HelpDir:		dword
global	HelpBuff:		dword
ifdef UNDERDEV
global	LstWordsFileN:		byte
endif

global	TraceBuffer:		dword
global	TraceBufferMaxSz:	dword

global	ControlStack0:		near
global	ControlStack:		near
global	ControlStackPtr:	dword

global	LoopStackNb:		dword:		MAXNB_THREADS
global	LoopStack:		loopentry:	LOOPSTACKMAXNB * MAXNB_THREADS

global	CaseStackNb:		dword:		MAXNB_THREADS
global	CaseStack:		dword:		CASESTACKMAXNB * MAXNB_THREADS

global	FileIOBuff:		dword

global	FileIOStatus:		word

global	AskVideoInfBuff:	dword

global	VOC_START:		dword
global	VOC_CURRENT:		dword
global	VOC_CONTEXT:		dword
global	VOC_NB:			dword
global	VOC_FFREED:		dword

global	NIA_START:		dword
global	NIA_SIZE:		dword

global	CrossRefNb:		dword
global	CrossRefTotalNb:	dword
global	CrossRef:		dword
global	CrossRefFFreed:		dword
global	CRefNdxRefRD:		dword
global	CRefNdxRefDR:		dword

global	CDA_START:		dword
global	CDA_SIZE:		dword
global	CDA_SIZE_INIT:		dword
global	CompileMode:		byte
global	LastWordDefWColon:	dword
global	CDA_COMMENT:		byte
global	CDA_SLASHSLASH:		byte
global	CDA_CURR_WORD:		dword
global	CDA_BRACKET_MODE:	byte
global	CDA_BUILD_CALLED:	byte
global	CDA_DOES_CALLED:	byte
global	CDA_ALLOT_CALLED:	byte
global	REF_BLK_ALLCTED:	dword
global	InfixExprEvalQ:		byte

global	ExeTag:			byte
global	ExeFile:		byte
global	ExeWordAddr:		dword
global	ExeCdaBegin:		dword
global	ExeCdaSize:		dword
global	ExeDdaBegin:		dword
global	ExeDdaSize:		dword
global	OfsDictReloc:		dword
global	Exe2ndPass:		byte

global	LDA_START:		dword
global	LDA_SIZE:		dword

global	DDIR_START:		dword
global	DDIR_SIZE:		dword
global	DDIR_SIZE_INIT:		dword
global	DDIR_FFREED:		dword
global	DDIR_MEMSALV:		dword

global	DDA_START:		dword
global	DDA_SIZE:		dword
global	DDA_SIZE_INIT:		dword
global	DDA_BOUND:		dword:		2
global	DynamicFlag:		byte
global	AllocFlag:		byte
global	AllocFound:		byte
global	FreeFlag:		byte
global	FreeFound:		byte
global	DynVarAddr:		dword

global	StartupLoaded:		byte
global	GreatingMsgPr:		byte

global	POWERTAB:		dword

global	KbdItInstalled:		byte
global	OldProtMIrq1:		dword
global	OldRealMIrq1:		dword
global	TwoSeq:			byte
global	FIFO:			word:	KB_FIFOSZ*2
global	FIFO_CharsNb:		dword
global	FIFO_head:		dword
global	FIFO_tail:		dword
global	ShiftState:		byte
global	CtrlState:		byte
global	AltState:		byte
global	ScanStates:		byte:	KB_MAXNBRECORDS
global	kbrmirqbuff:		byte:	21
